;
; OS ROUTINE LINKAGES
;
AORN	.EQU	0E56AH		; ALPHANUMERIC DETERMINATION
ASBIN	.EQU	0E583H		; ASCII TO BINARY
CRLF	.EQU	0E59CH		; OUTPUT CR AND LF
DSCAN	.EQU	0E414H		; DDT-80 SCAN ROUTINE
ECHO	.EQU	0E597H		; INPUT AND OUTPUT
PACC	.EQU	0E58BH		; CONVERT TO ASCII
PADDO	.EQU	0E604H		; CONVERT HL TO ASCII AND OUTPUT
PRVAL	.EQU	0E5AFH		; CONVERT TO ASCII AND OUTPUT
PTWDG	.EQU	0E311H		; CONVERT TO ASCII, OUTPUT, AND BINARY CHECKSUM
PTXT	.EQU	0E3C7H		; OUTPUT HL-> TEXT TO 03H
RDCHR	.EQU	0E522H		; READ A CHARACTER
SPACE	.EQU	0E5A5H		; OUTPUT A BLANK
WRCHR	.EQU	0E527H		; WRITE A CHARACTER
MONITR	.EQU	0E11DH		; RETURN TO MONITOR
;
; SCRATCHPAD RAM LINKAGES
;
ENDA	.EQU	0FF00H		;
ENDB	.EQU	0FF02H		;
ENDC	.EQU	0FF04H		;
ENDD	.EQU	0FF06H		;
MEMFLG	.EQU	0FF08H		;
OPR1	.EQU	0FF14H		; OPERAND 1 FROM DDT-80
OPR2	.EQU	0FF16H		; OPERAND 2 FROM DDT-80
OPR3	.EQU	0FF18H		; OPERAND 3 FROM DDT-80
OPFLG	.EQU	0FF1AH		; NBR OF OPERANDS FROM DDT-80
;
; MACRO HANDLER LINKAGES
;
DEFINE	.EQU	3FF5H		;
EXPAND	.EQU	3FF8H		;
SEARCH	.EQU	3FFBH		;
MACEND	.EQU	3FFEH		;
;

ONBYLM	.EQU	80
FRBYLM	.EQU	106
;
; LINKS INTO MEMORY MAPPING MODULE
;
AUTOCK	.EQU	0DED3H		; PAPER TAPE VERSION
LPTXT	.EQU	0DDEEH		; PTXT IN LOADER
;
; ZERO INITIALIZE AREA FOR PASS 1 AND PASS2
;
REFL	.EQU	08H		;
REFH	.EQU	09H		;
PAGNUM	.EQU	0AH		;
LASREF	.EQU	0CH		;
STADDR	.EQU	0EH		;
EXADDR	.EQU	10H		;
STMENT	.EQU	12H		;
ERRNBR	.EQU	14H		;
LDFLAG	.EQU	16H		;
ABSFLG	.EQU	0		; ABSOLUTE ASSEMBLY FLAG
OCOUNT	.EQU	17H		; OBJECT BUFFER COUNTER
RCOUNT	.EQU	18H		; RELOCATING BUFFER COUNTER
;
LCOUNT	.EQU	19H		; LISTING BUFFER COUNTER
ERRCOD	.EQU	1AH		; ERROR CODE
;
SFLAG	.EQU	1BH		; SOURCE STATEMENT FLAG
RESFLG	.EQU	7		; RESET OVERFLOW FLAG
EQUMOD	.EQU	6		; EQUATE MODE FLAG
ASMFLG	.EQU	5		; ASSEMBLER DIRECTIVE FLAG
RELFLG	.EQU	4		; RELOCATABLE OPERAND
LABFLG	.EQU	3		; LABEL IN SOURCE STATEMENT
EXTFLG	.EQU	2		; EXTERNAL REFERENCE FOUND
LRLFLG	.EQU	1		; LISTING RELOCATE FLAG
EXTOK	.EQU	0		; EXTERNAL REF OK FOR THIS OPCODE
;
OPLEN	.EQU	1CH		; OPCODE LENGTH
OPTYPE	.EQU	1DH		; OPCODE TYPE
OPC	.EQU	1EH		; OPCODE INDEX
OP1	.EQU	1FH		; OPERAND 1 INDEX
;
OP2	.EQU	20H		; OPERAND 2 INDEX
CFLAG	.EQU	21H		; ASSEMBLY CONTROL FLAG
IFFLAG	.EQU	7		; CONDITIONAL ASSEMBLY BIT
MACDEF	.EQU	6		; MACRO DEFINITION MODE
MACEXP	.EQU	5		; MACRO EXPANSIONS MODE
ENDFLG	.EQU	4		; END STATEMENT ENCOUNTERED
LISTON	.EQU	3		; LISTING ON ASM CMD
MACLON	.EQU	2		; MACLIST ON COMMAND
STXFLG	.EQU	1		; START OF TEXT FLAG
PSECTF	.EQU	0		; PSECT FLAG
;
; FLAGS
;
OPFLAG	.EQU	22H		; OPERATIONS FLAG
PASS2	.EQU	7		; PASS 2 INDICATOR BIT
FSTOBJ	.EQU	6		; FIRST OBJECT BYTE FLAG
RESSYM	.EQU	5		; RESET SYMBOL TABLE FLAG
MACRO	.EQU	3		; MACRO OPTION FLAG
OBJFLG	.EQU	2		; OBJECT OUTPUT FLAG
SYMFLG	.EQU	1		; SYMBOL TABLE R.EQUESTED
LISTING	.EQU	0		; LISTING REQUESTED FLAG
;
; SYMBOL TABLE FLAG POINTERS
;
FSTEXT	.EQU	5		; FIRST EXTERNAL REFERENCE
GLBFLG	.EQU	2		; GLOBAL REFERENCE FLAG
DEFIN2	.EQU	1		; DEFINED DURING PASS 2
DEFIN1	.EQU	0		; DEFINED DURING PASS 1
;
IYMASK	.EQU	23H		; IY MASK FOR BUILD
;
OP1POS	.EQU	24H		; POSITION OF OPERAND 1 IN SOURCE
OP2POS	.EQU	26H		; POSITION OF OPERAND 2 IN SOURCE
;
VALEQU	.EQU	28H		; VALUE OF AN .EQUATED SYMBOL
;
SYMPTR	.EQU	2AH		; SYMBOL TABLE POINTER
SYMTAB	.EQU	2CH		; START OF SYMBOL TABLE
SYMEND	.EQU	2EH		; END OF SYMBOL TABLE
;
LINNUM	.EQU	30H		; LINE NUMBER ON A PAGE
OPOINT	.EQU	32H		; OBJECT DATA POINTER
LPOINT	.EQU	34H		; LISTING BUF PTR FOT OBJECT CODE
RPOINT	.EQU	36H		; RELOCATION BUFFER POINTER
OOCHNL	.EQU	38H		;
SICHNL	.EQU	39H		;
SOCHNL	.EQU	3AH		;
SAVE1	.EQU	3CH		; SAVE AREA FOR 'BUILD'
LABPOS	.EQU	3EH		; LABEL POSITION IN SOURCE
RFLG	.EQU	41H		;
;
; ERROR CODES
;
LBLERR	.EQU	'L'		; INVALID LABEL
OPCERR	.EQU	'O'		; INVALID OPCODE
OPRERR	.EQU	'I'		; INVALID OPERAND
SYNTAX	.EQU	'S'		; SYNTAX ERROR
UNDEFR	.EQU	'U'		; UNDEFINED SYMBOL
MLTDEF	.EQU	'M'		; MULTIPLY DEFINED SYMBOL
PSECTR	.EQU	'P'		; ONLY ONE PSECT ALLOWED
TABFUL	.EQU	'F'		; SYMBOL TABLE FULL
EXTEXP	.EQU	'E'		; EXTERNAL SYMBOL CANNOT BE USED IN AN EXPR
MACERR	.EQU	'W'		; MACRO CANNOT BE DEFINED WITHOUT OPTION
UNQUOT	.EQU	'Q'		; UNBALANCED QUOTES
LABREQ	.EQU	'N'		; LABEL R.EQUIRED ON .EQU OR DEFL
OVFERR	.EQU	'V'		; RANGE ERROR (EXPRESSION OUT OF RANGE)
RNGERR	.EQU	'R'		; RANGE ERROR
DIGERR	.EQU	'D'		; ILLEGAL DIGIT
BADOPR	.EQU	'B'		; ILLEGAL OPERATOR
MAPERR	.EQU	'X'		; SYMBOL TABLE MAP ERROR
TRNERR	.EQU	'T'		; INPUT TRUNCATED ERROR
;
; BUFFERS
;
SRCBUF	.EQU	50H		; SOURCE INPUT BUFFER
MSGBUF	.EQU	0D0H		; DEFM MESSAGE BUFFER
LBUF	.EQU	190H		; OBJECT CODE BUFFER FOR LISTING
TEMBUF	.EQU	194H		; TEMPORARY BUFFER
NAMBUF	.EQU	1A9H		; MODULE NAME BUFFER
HEADING	.EQU	1B0H		; USER HEADING BUFFER
HEADLN	.EQU	32		; LENGTH OF USER HEADING BUFFER
SYMBUF	.EQU	1F8H		; SYMBOL BUFFER (TEMPORARY)
OBUF	.EQU	200H		; OBJECT OUTPUT BUFFER
RBUF	.EQU	250H		; RELOCATION OUTPUT BUFFER
STACK	.EQU	300H		; ASSEMBLER STACK
;
; BASEPAGE CONSTANTS
;
WIDTH	.EQU	127		; MAX OUTPUT LISTING WIDTH
NULL	.EQU	0FEH		;
NULL3	.EQU	03EH		; NULL FOR OPERANDS
;
CR	.EQU	0DH		;
HT	.EQU	09H		;
LF	.EQU	0AH		;
DELIM	.EQU	'&'		;
;
LINMAX	.EQU	58		; MAX LINES PER PAGE
NOPOPS	.EQU	13		; MAX INDEX OF ONE BYTE
ONELIM	.EQU	63		;
TWOLIM	.EQU	138		;
THRLIM	.EQU	176		;
;
; OPCODES WITH NO OPERANDS PLUS ONE
;
NONOPS	.EQU	215		; INDEX OF NON CODE OPCODES
DEFB	.EQU	212		;
DEFM	.EQU	213		;
DEFS	.EQU	215		;
ORG	.EQU	219		;
EQUTYP	.EQU	230		; INDEX OF EQU TYPE OPCODES
EQU	.EQU	230		;
DEFL	.EQU	231		;
A_	.EQU	7		;
REG_	.EQU	27		;
EREG_	.EQU	29		;
PIXP_	.EQU	11+32		;
PIYP_	.EQU	12+32		;
IX_	.EQU	11		;
IY_	.EQU	12		;
IXORIY	.EQU	28		;
PIXIYP	.EQU	28+32		;
EXP	.EQU	26		;
PEXP	.EQU	26+32		;
ANY	.EQU	31		; ANY OPERAND ALLOWED
;
; ASSEMBLER MAIN PROGRAM
;
	.ORG	0C000H
;
; LOADER TEXT OUTPUT ROUTINE TO CONSOLE
;
	LD	SP,STACK	; INIT STACK POINTER
;
; INITIALIZE SDB-80 INTERRUPT VECTOR
;
	LD	A,0E7H		;
	LD	I,A		;
	LD	IX,0		; IX -> RAM
;
; INITIALIZE CHANNEL NUMBER
;
	LD	(IX+OOCHNL),0BH	; OBJECT OUTPUT
	LD	(IX+SOCHNL),0DH	; SOURCE OUTPUT
;
	CALL	INIT1		; INITIALIZE FOR PASS 1
;
; IF PASS 2 SELECTED, SKIP TO END OF LOOP
;
	JR	NZ,PAS2DO	;
;
;INIT VARIABLES FOR PASS 1 AND PASS 2
;
; INITIALIZE RAM AREAS
;
LOOP:	LD	HL,REFL		; START OF AREA
	LD	B,OPTYPE-REFL	; LENGTH OF AREA
INITAL:	LD	(HL),0		; SET TO ZERO
	INC	HL		; INCR PTR
	DJNZ	INITAL		; LOOP FOR ALL
;
;INITIALIZE BUFFER AREA
;
	LD	HL,NAMBUF	; HL -> START OF BUFFERS
	LD	B,HEADLN+7	; LENGTH
INIBUF:	LD	(HL),' '	; INIT TO BLANKS
	INC	HL		; INCR PTR
	DJNZ	INIBUF		; LOOP FOR ALL
;
; ETX AT END OF HEADING BUFFER
;
	LD	(HL),03H	;
	LD	(IX+CFLAG),0CH	;
	LD	(IX+SICHNL),1100B	; SOURCE INPUT CH
	LD	(IX+LINNUM),LINMAX	; MAX LINE NUMBER
	LD	HL,OBUF		; INIT OBJECT POINTER
	LD	(OPOINT),HL	;
	LD	HL,RBUF		; INIT RELOCATION PTR
	LD	(RPOINT),HL	;
;
LOOPA:	CALL	SOURCE		; READ SOURCE STATEMENT
	JR	C,PAS2		; IF EOT,SKIP TO PASS 2
;
; CHECK MACRO DEFINITION MODE FLAG
;
	BIT	MACDEF,(IX+CFLAG)
	JR	Z,CONTA		;
	CALL	DEFINE		; DEFINE THE MACRO
	JR	LOOPA		; LOOP FOR MORE SOURCE
;
CONTA:	CALL	SCAN		; SCAN THE SOURCE LINE
	CALL	INSTID		; DECODE THE INSTRUCTION
	CALL	BUILD		; BUILD THE OBJECT CODE
	CALL	LIST		; ASSEMBLY LISTING
;
;TRACK THE REFERENCE COUNTER
;
	LD	HL,(LASREF)
	LD	(REFL),HL	; AND SAVE IT
	BIT	ENDFLG,(IX+CFLAG);END STATMENT
	JR	Z,LOOPA		; NO, LOOP FOR MORE SOURCE
;
; PASS 2 DEFINITION
;
PAS2:	BIT	PASS2,(IX+OPFLAG);PASS 2 DONE ?
	JR	NZ,FINISH	; YES, SKIP
	CALL	INIT2		; INITIALIZE PASS 2
;
; REINIT SYMBOL TABLE FOR PASS 2
; AND OUTPUT INT AND EXT SYMBOLS
; FOR OBJECT OUTPUT
;
PAS2DO:	CALL	STOUT		;
	JR	LOOP		; LOOP FOR MORE SOURCE
;
;FINISH THE ASSEMBLY
;
FINISH:	CALL	OBJOUT		; FINISH OBJECT OUTPUT
	CALL	RELOUT		; FINISH RELOCATING OUTPUT
OBJEOT:	LD	HL,(EXADDR)	; END OF OBJECT OUTPUT
;
; SUBSTITUTE EXECUTION ADDRESS FOR START ADDRESS
;
	LD	(STADDR),HL	;
	CALL	OBJOUT+5	; FINISH OBJECT OUTPUT
	CALL	STP		; PRINT SYMBOL TABLE
	BIT	LISTING,(IX+OPFLAG);LISTING OUTPUT
	LD	E,4		; OUTPUT # OF ERRORS ON LISTING
	CALL	NZ,ERRP		; YES, OUTPUT TO :SO
	LD	E,0		; CONSOLE DEVICE
	CALL	ERRP		; PRINT OUT NBR OF ERRORS
	JP	MONITR		; RET TO MONITOR
;
ERRP:	LD	HL,ERNMSG	; # OF ERRORS MESSAGE
	CALL	PTXT		;
	LD	HL,(ERRNBR)	; NUMBER OF ERRORS
	CALL	PADDO		;
	RET			;
;
ERNMSG:	.WORD	0A0DH		; CR AND LF
	.BYTE	"ERRORS="	;
	.BYTE	03H		; ETX OF MESSAGE
;
; INITIALIZE FOR PASS 1
;
INIT1:	LD	HL,NAMMSG	; PRINT NAME AND OPTION R
	CALL	LPTXT		;
;
;SET LISTON AND MACLIST ON FLAGS
;
OPTINI:	LD	C,05H		; OPERATIONS FLAG
;
; GET AND DECODE OPTIONS
;
OPTION:	CALL	ECHO		; GET AND ECHO CHARACTER
	LD	A,D		; GET OPTION CHARACTER
	CP	CR		;
	JR	Z,OPTDON	; YES,SKIP OUT
	CP	'.'		; DOT ?
	JR	Z,INIT1		; YES,START OVER
	SUB	'J'		; SUBTRACT FIRST OPERATION
	LD	B,A		;
	DJNZ	OPTL		; K? NO LISTING?
	RES	LISTING,C	;
;
;FALL THRU THE REST TO SAVE BYTES
;
OPTL:	DJNZ	OPTM		; L? LISTING?
	SET	LISTING,C	;
OPTM:	DJNZ	OPTN		; M? MACRO OPTION?
	SET	MACRO,C		;
OPTN:	DJNZ	OPTO		; N? NO OBLECT
	RES	OBJFLG,C	;
OPTO:	DJNZ	OPTP		; O? OBJECT OUTPUT
	SET	OBJFLG,C	;
OPTP:	DJNZ	OPTQ		; P? PASS 2 OPTION?
	SET	PASS2,C		;
OPTQ:	DEC	B		; Q? QUIT?
	JP	Z,MONITR	; QUIT COMMAND
	DJNZ	OPTS		; R? RESET SYMBOL TABLE?	
	SET	RESSYM,C	; YES, SET FLAG
OPTS:	DJNZ	OPTNOP		; S? SYMBOL TABLE?
	SET	SYMFLG,C	;
OPTNOP:	CALL	SPACE		; OUTPUT A SPACE
	JR	OPTION		; GO GET MORE OPTIONS
;
OPTDON:	CALL	CRLF		; OUTPUT CR AND LF
	LD	(IX+OPFLAG),C	; SAVE OPERATIONS FLAG
	BIT	RESSYM,C	; RESET SYMBOL TABLE?
	JR	NZ,SRESET	; YES, SKIP
	BIT	PASS2,C		; PASS 2 REQUESTED?
	RET	NZ
;
; CHECK FOR MEMORY MAPPING AND SET
; UP APPROPRIATE LIMITS FOR SYMBOL TABLE
;
SRESET:	CALL	AUTOCK		; CHECK MEMORY MAPPING OP
	LD	DE,300H		; DEFAULT BEGINNING 
	LD	HL,(ENDC)	; SET UPPER LIMIT
;
; RESET SYMBOL TABLE FLAG
;
	RES	RESSYM,(IX+OPFLAG)
;
; IF AUTO MEMORY MAPPING, SKIP
;
	JR	Z,DONMAP	; YES,SKIP
;
; IF NOT MEMORY MAPPING, OUTPUT CONSOLE
; MESSAGE ASKING FOR SYMBOL TABLE LIMITS
;
SKPMAP:	PUSH	DE		;
	LD	HL,SYMMSG	;
	CALL	LPTXT		; OUTPUT MESSAGE
	CALL	DSCAN		; AND SCAN FOR OPERANDS
	POP	DE		;
;
; DEFAULT END OF SYMBOL TABLE
;
	LD	HL,0E00H	; SET END OF TABLE
	LD	A,(OPFLG)	; GET NBR OF OPERANDS
	AND	A		;
	JR	Z,DONMAP	; IF NO OPERANDS, SKIP
;
; GET AND SAVE FIRST LIMIT
;
	LD	DE,(OPR1)	; GET OPERAND 1
	CP	1		; ONE LIMIT?
	JR	Z,DONMAP	; IF SO, SKIP
	LD	HL,(OPR2)	; GET OPERAND 2
;
; END OF MAPPING, NOW CHECK LIMITS
;
DONMAP:	LD	(SYMTAB),DE	; DE -> START OF TABLE
	LD	(SYMEND),HL	; HL -> END OF TABLE
	SCF			;
	SBC	HL,DE		; HL-DE-1
	JR	NC,MAPOK	; IF HL>DE, OK
;
MAPNOK:	LD	A,MAPERR	;
	JP	ABORT		; END ABORT ASSEBLER
;
; SYMBOL TABLE CANNNOT EXTEND BELOW 300H
;
MAPOK:	PUSH	HL		;
	POP	BC		;
	DEC	BC		;
	LD	HL,$2FF		; LOWER LIMIT
;
; CARRY SHOULD BE RESET
;
	SBC	HL,DE		; 300H-START OF TABLE
	JR	NC,MAPNOK	; IF ERPOP, QKIP MUT
	PUSH	DE		;
	POP	HL		;
	LD	(SYMPTR),HL	; INITIAIZE POINTER
	INC	DE		; INCPEMENT TO TABLE+1
	LD	(HL),7FH	; INIT FIRST LOCATIOL
	LDIR			;
;
; THIS INITIALIZES SYMBOL TABLE TO ALL 7F'S
;
; RETURN ZERO FOR PASS 1, NONZERO FOR PASS 2
;
	BIT	PASS2,(IX+OPFLAG)
	RET			;
;
; INITIALIZATION FOR PASS 2
;
INIT2:	SET	PASS2,(IX+OPFLAG);PASS 2 INDICATION
	LD	HL,PS2MSG	; HL -> PASS 2 MESSAGE
	CALL	LPTXT		;
	CALL	ECHO		;
	CALL	CRLF		;
	RET			;
;
NAMMSG:	.BYTE	"OPTIONS?"	;
	.BYTE	03H		;
;
SYMMSG:	.BYTE	"SYMBOL TABLE LIMITS?"
	.BYTE	03H		;
;
PS2MSG:	.BYTE	"READY PASS2?"	;
	.BYTE	03H		;
;
; SOURCE INPUT ROUTINE
; INIT VARIABLES
;
SOURCE:	LD	A,NULL		; NULL
	LD	(IX+OPC),A	; OPCODE INDEX
	AND	3FH		;
	LD	(IX+OP1),A	; OPERAND 1 INDEX
	LD	(IX+OP2),A	; OPERAND 2 INDEX
	LD	HL,LBUF		; INIT BUFFER
	LD	(LPOINT),HL	; POINTER
;
; INIT RAM AREA
;
	LD	HL,LCOUNT	; HL -> START
	LD	B,OPTYPE-LCOUNT	; LENGTH
SCINIT:	LD	(HL),0		; INIT TO ZERO
	INC	HL		;
	DJNZ	SCINIT		;
	LD	HL,SRCBUF	; HL -> SOURCE BUFFER
	LD	B,WIDTH		; MAXIMUM BUFFER SIZE
;
; CHECK FOR MACRO EXPANSION
;
ILOOP:	BIT	MACEXP,(IX+CFLAG);
	JR	Z,ILR		; IF NOT SET, SKIP
;
; CALL EXTERNAL MACRO EXPANSION ROUTINE
; TO EXPAND MACRO FOR ASSEMBLER
;
	CALL	EXPAND		;
	JR	ILS		;
;
ILR:	LD	E,(IX+SICHNL)	; CHANNEL NBR
	CALL	RDCHR		;
	LD	(IX+SICHNL),E	; REINIT CHANNEL NBR
ILS:	AND	7FH		; REMOVE PARITY
	JR	Z,ILOOP		; IGNORE NULLS
;
; IGNORE ALL BUT STX CHARACTER?
;
	BIT	STXFLG,(IX+SFLAG);
	JR	Z,IGO		;
	CP	02H		; STX YET?
	JR	NZ,ILOOP	; NO LOOOP UNTIL STX
;
; STX ENCOUNTERED, RESET STXFLG TO CONTINUE
;
	RES	STXFLG,(IX+SFLAG);
	JR	ILOOP		; LOOP FOR MORE
;
IGO:	CP	7FH		; IGNORE RUBOUTS
	JR	Z,ILOOP		;
	CP	LF		; IGNORE LF'S
	JR	Z,ILOOP		;
	CP	03H		; ETX?
	JR	Z,ETX		; YES, END OF FILE
	CP	04H		; EOT?
	JR	Z,EOT		; EOT, FINISH ASM
	LD	(HL),D		; PUT CHAR INTO SOURCE BUFFER
	INC	HL		;
	CP	CR		; CHECKFOR CR
	JR	Z,RETPT2	; YES SKIT OUT
	DJNZ	ILOOP		; CHECK WIDTH OF INPUT
	LD	(IX+ERRCOD),TRNERR;TRUNCATED ERROR
;
; TRUNCATE INPUT
;
	LD	(HL),CR		; PUT CR INTO BUFFER
RETPT2:	XOR	A		;
	RET			; TO CALLER
;
EOT:	SCF			; SET CARRY TO SHOW BOT
	RET			;
;
ETX:	SET	STXFLG,(IX+SFLAG);
	JR	ILOOP		; AND GO READ MORE
;
; SCANS SOURCE LINE AND DECODES LABEL,
; ENTERS LABEL INTO SYMBOL TABLE,
; DECODES OPERANDS AND OPCODES,
; SETS UP OPCODE INDEX
; SETS UP OPERAND INDICES.
;
; REGISTER USAGE:
; HL -> SOURCE , CHANGED
; ALL OTHER REGISTER CHANGED
; PRIMED REGISTER NOT CHANGED
; IY CHANGED.
;
SCAN:	LD	HL,SRCBUF	; HL ->SOURCE BUFFER
	CALL	SEMICR		; CHECK FOR CR OR ;
	RET	Z		; IF SO, RETURN
	CP	'*'		; CHECK FOR ASM CMD
	RET	Z		; IF COMMENT, RETURN
; SET BIT 7 OF CHARACTERS IN QUOTES
;
	PUSH	HL		; SAVE HL
	LD	C,27H		; SET UP A QUOTE CHAR
QUOTE1:	INC	HL		; INCR SOURCE PTR
	CALL	SEMICR		; CHECK FOR CR OR ;
	JR	Z,ALTER		; DONE, SKIP OUT
	CP	C		; 1ST QUOTE
	JR	NZ,QUOTE1	; NO, LOOP FOR MORE
	DEC	HL		; CHECK FOR PRECEDING F
	LD	A,(HL)		; TO HANDLE F'
	CP	'F'		;
	INC	HL		; GET TO QUOTE CHAR
	JR	Z,QUOTE1	; F FOUND, LOOP FOR MORE
;
; (IGNORE QUOTE CHARACTER)
;
QUOTE2:	INC	HL		; GET TO NEXT CHAR
	LD	A,(HL)		; GET IT
	CP	C		; CLOSING QUOTE?
	JR	Z,QUOTE1	; IF SO, LOOP BACK
	CP	0DH		; CR?
	SET	7,(HL)		; ELSE SET BIT 7 OF CHARACTER
	JR	NZ,QUOTE2	; AND LOOP FOR MORE
	LD	(IX+ERRCOD),UNQUOT;SET ERROR...
;
ALTER:	POP	HL		; HL ->SOURCE
;
; SCAN FOR LABEL
;
	CALL	CHKDEL		; LABEL STARTING IN COL 1
	JR	NZ,LABEL	; YES, SKIP
	CALL	NXTCHR		; GET NEXT NONBLANK CHAR
	RET	Z		; RETUR FOR CR OR ;
;
; CHECK FOR LABEL DEFINED BY TRAILING COLON
;
	PUSH	HL		; SAVE HL
CHKLBL:	LD	A,(HL)		; GET CHAR
	CP	':'		; IS IT A COLON?
	JR	Z,LABPOP	; YES, LABEL, SKIP
	CALL	CHKDEL		; CHECK FOR DELIMITER
	JR	Z,POPCOD	; YES, OPCODE, SKIP
	INC	HL		; INCR PTR
	JR	CHKLBL		; AND LOOP FOR MORE
;
; COLON FOUND DEFINING A LABEL
;
LABPOP:	POP	HL		; HL -> LABEL
LABEL:	SET	LABFLG,(IX+SFLAG);SET LABEL FLAG
;
; LABEL STUFF INTO SYMBOL TABLE
;
	LD	(LABPOS),HL	; SAVE POSITION
	PUSH	HL		; SAVE POSITION
	LD	A,1		; ENTER SYMBOL INTO TABLE
	CALL	SYMBOL		; PUT LABEL INTO SYMBOL TABLE
	POP	HL		; RESTORE SOURCE PTR
	SET	RELFLG,(IY+6)	; SET RELOCATABLE FLAG
	SET	RELFLG,(IX+SFLAG);AND FOR SOURCE
	CALL	NXTFLD		; GET TO NEXT NON-BLANK F
	JR	NZ,CHKOPC	; IF FOUND, SKIP
;
; THIS IS FOR A SYMBOL WITHOUT ANYTHING ELSE IN TABLE
;
	LD	HL,(REFL)	; SAVE VALUE OF EQUATE
	LD	(VALEQU),HL	;
	RET			;
;
; OPCODE DECODING
;
POPCOD:	POP	HL		;
CHKOPC:	BIT	MACRO,(IX+OPFLAG); CHECK MACEO OPT
;
; IF MACRO OPTION, EALL EXTERNAL ROUTINE TO
; SEARCH FOR MACRO NAME
;
	JR	Z,SOPCOD	; NO MACRO OPTION, SKIP
	CALL	SEARCH		; ELSE LINK TO EXTERNAL R
;
; IF MACRO NAME NOT FOUND, SKIP TO
; SEARCH OPCODE TABLE
;
	JR	NZ,SOPCOD	;
;
; ELSE SET MACRO EXPANSIONS FLAG
;
	SET 	MACEXP,(IX+CFLAG);
	RET			;
;
SOPCOD:	LD	IY,OPCODS	; IY -> OPCODE TABLE
	CALL	FIND		; SEARCH FOR OPCODE
	JR	Z,OPCFND	; IF FOUND, SKIP
	LD	(IX+ERRCOD),OPCERR;ELSE INVALID OPCODE
	RET			;
;
OPCFND:	LD	(IX+OPC),C	; SAVE OPCODE INDEX
;
; ZERO IYMASK FOR IY TYPE OPCODES
;
	LD	(IX+IYMASK),0	;
	CALL	NXTFLD		; GET NEXT FIELD
	RET	Z		; RETURN IF CR OR
	LD	(OP1POS),HL	; SAVE POSITION OF OP1
	LD	IY,KEYWDS	; IY -> KEYWDS TABLE
	CALL	FIND		; GO FIND IT
	LD	A,0		; SET CALL CODE FOR OP1
;
;*****ABOVE LINE MUST BE A LOAD
;
	CALL	NZ,ANALYZ	; IF NOT FOUND, ANALYZ OP
	RET	NZ		; RETURN IF ERROR
	LD	(IX+OP1),C	; SAVE INDEX FOR OPERAND
	CALL	NXTFLD		; GET NEXT FIELD
	RET	Z		; RETURN FOR CR OR ;
	LD	(OP2POS),HL	; SAVE OPERAND 2 POSITION
	LD	IY,KEYWDS	; IY -> KEYWDS TABLE
	CALL	FIND		; FIND OPERAND
	LD	A,1		; SET CALL CODE FOR OP2
	CALL	NZ,ANALYZ	; IF NOT FOUND, ANALYZ
	RET	NZ		; RETURN IF ERRORS
	LD	(IX+OP2),C	; SAVE OPERAND 2 INDEX
	RET			;
;
; PRELIMINARY EXPRESSION CHECK
;
; REGISTER USAGE:
;  A-M  0 FOR OP1, 1 FOR OP1
;  C-RETURNED INDEX
;  HL -> SOURCE (KHANGED)
;  IY-X
;
; CHECK BALANCING OF PARENTHESES
;
ANALYZ:	EX	AF,AF'		; SAVE CALL CODE
	PUSH	HL		; SAVE SOURCE PTR
	LD	C,0		; SET COUNTER
	LD	E,C		; CLEAR PARENTHESES COUNTER
;
PLOOP:	INC	C		; INCREMENT COUNTER
	LD	A,'('		; GET LEFT PARENTHESES
	CP	(HL)		; CHECK FOR LEFT PARENTHESES
	JR	NZ,NOTLP	; IF NOT, SKIP
	INC	E		; INCR PARENTHESES COUNTER
;
NOTLP:	INC	A		; GET RIGHT PARENTHESES
	CP	(HL)		; CHECK FOR RIGHT PARENTHESES
	JR	NZ,NOTRP	; IF NOT, SKIP
	DEC	E		; DECR PARENTHESES COUNTER
;
NOTRP:	CALL	CHKDEL		; CHECK FOR DELIMITER
	INC	HL		; INCR POINTER
	JR	NZ,PLOOP	; IF NOT DELIM, LOOP FOR
;
; DELIMITER FOUND, CHECK IF EXPRESSION WHOLLY IN PARENS
; FIRST CHECK FOR BALANCED PARENS
;
	LD	A,E		;
	AND	A		;
	JR	Z,EXPOK		; IF ZERO, OK
	LD	(IX+ERRCOD),SYNTAX;ELSE SYNTAX ERROR
	POP	HL		; RESTORE SOURCE PTR
	RET			; RETURN TO CALLER
;
EXPOK:	DEC	HL		; CHECK PREVIOUS CHARACTER
	DEC	HL		; DECR AGAIN
	LD	A,')'		; GET RIGHT PAREN
	CP	(HL)		; RIGHT PAREN?
	POP	HL		; RESTORE SOURCE POINTER
	JR	NZ,EXPNOT	; NOT IN PAREN, SKIP
	DEC	A		; GET LEFT PAREN
	CP	(HL)		; LEFT PAREN?
	JR	Z,EPAREN	; IT IS IN PARENS, SKIP
;
; EXPRESSION NOT IN PARENS
;
EXPNOT:	LD	C,EXP		; SET INDEX
	SUB	A		; RETURN ZERO
	RET			;
;
; EXPRESSION IN PARENS, DECODE IT
;
EPAREN:	LD	A,C		; CHECK FOR COUNT > 5
	INC	HL		; GET PAST PAREN
	CP	6		; COUNT - 6
	JR	NC,EE		; YES, CHECK FOR EXPR IN
;
; ELSE CHECK FOR KEYWD IN PARENS
;
; SET UP TEMPORARY BUFFER WITH KEYWORD IN IT
; ENDED BY A DELIMITER, NOI ')'.
;
	PUSH	HL		;
	SUB	3		; GET LENGTH OF KEYWORD !!!
	LD	C,A		; INTO BC
	LD	B,0		;
	LD	DE,SYMBUF	; PLACE INTO A BUFFER
	PUSH	DE		; SAVE IT
;
; HL -> SOURCE, DE -> DESTINATION, BC= COUNT
;
	LDIR			; (DE) <- (HL) FOR BC
	EX	DE,HL		; HL -> NEW SOURCE KEYWORD
	LD	(HL),','	; SET A DELIMITER
	POP	HL		; HL -> SYMBUF
	LD	IY,KEYWDS	; IY -> KEYWDS TABLE
	CALL	FIND		; FIND KEYWDS, IF POSSIBLE
	POP	HL		; RESTORE SOURCE POINTER
	JR	NZ,EE		; NOT FOUND, SKIP
;
; KEY WORD FOUND IN PARENS
;
	SET	5,C		; ADJUST INDEX
	SUB	A		; ZERO
	RET			;
;
; EXPRESSION IN PARENS, CHECK FOR IX+, IY-, IY+, OR IY-
;
EE:	LD	A,(HL)		; GET FIRST CHARACTER
	CP	'I'		; CHECK FOR I
	JR	NZ,EXPFND	; EXPRESSION, NOT IX OR
	INC	HL		; CHECK FOR NEXT CHAR FOR IX
	LD	A,(HL)		;
	CP	'X'		;
	JR	Z,IXFND		; IX FOUND
	CP	'Y'		; CHECK FOR IY
	JR	NZ,EXPFND	; NO, EXPRESSION
	SET	5,(IX+IYMASK)	; SET IY MASK
IXFND:	INC	HL		; GET NEXT CHARACTER
	LD	A,(HL)		;
	CP	'+'		; CHECK FOR PLUS
	JR	Z,PLSFND	; PLUR FOUND, SKIP
	CP	'-'		; CHECK FOR MINUS
	JR	NZ,EXPFND	; EXPRESSION
;
;	IX+, IX-, IY+, IY- FOUND
;
PLSFND:	LD	C,PIXIYP	; SET INDEX
	EX	AF,AF'		; GET CALL CODE
	AND	A		; CHECK IT
	JR	Z,ANAOP1	; OPERAND 1
	LD	(OP2POS),HL	; SAVE OPERAND 2 POSITION
	SUB	A		; ZERO
	RET			;
;
ANAOP1:	LD	(OP1POS),HL	; SAVE OPERAND 1 POSITION
	RET			;
;
; EXPRESSION IN PARENTHESES
;
EXPFND:	LD	C,PEXP		; RETURN EXPRESSION INDEX
	SUB	A		; RETURN ZERO
	RET			;
;
; SUBROUTINE TO FIND A STRING IN A TABLE
;
; REGISTER USAGE:
;  A-X
;  B-X = INDEX7
;  C-R=INDEX
;  HL - M (SOURCE PTR)
;  IY - I (TABLE TO BE SEARCHED)
;	
; ZERO - MATCH FOUND
; NON ZERO NO MATCH
;
FIND:	LD	C,0		; INIT INDEX
	LD	B,0		; INIT INDEX7
	PUSH	HL		; SAVE SRC PTR
MATCH:	CALL	GET5		; GET NEXT  CHAR FROM SEAR
HUNT:	CP	(HL)		; CHECK AGAINST SOURCE
;
; IF NO MATCH, GM TO NEXT TA@LE ITEM
;
	JR	NZ,NEXT		;
	INC	HL		; MATCH, INC PTR
	CALL	CHKDEL		; LOOK FOR SOURCE DELIMITD
	JR	Z,ENDX		; FOUND CHECK FOR END
	LD	A,D		; GET TABLE CHAR
	CP	DELIM		; DELIMITER?
	JR	NZ,MATCH	; NOT DELIMITER, LOOP FOR
	JR	EOFX		;
;
; FIND END OF TABLE ITEM
;
BUMP:	CALL	GET5		; GET NEXT CHAR FROM
NEXT:	CP	DELIM		; DELIMITER?
	JR	NZ,BUMP		; NO, LOOP UNTIL FOUND
	CALL	GET5		; GET NEXT CHARACTER
EOFX:	INC	C		; INCREMENT COUNTER
	POP	HL		; HL -> SOURCE
	PUSH	HL		;
	CP	'*'		; EOT?
	JR	NZ,HUNT		; NOT END, LONP FOR NEXT
	INC	A		; SET NON ZERO
	POP	HL		;
	RET			;
;
; (FAILURE)
;
ENDX:	CALL	GET5		; GET NEXT CHAR
	CP	DELIM		;
	JR	NZ,BUMP		;
;
; CHECK FOR IY
;
	LD	A,C		; GET INDEX
	CP	IY_		; CHECK IS NOT FOUND
	JR	NZ,IYNOT	; IF NOT SKIP
	SET	5,(IX+IYMASK)	; ELSE SET IYMASK
IYNOT:	CP	A		; SET ZERO
	POP	HL		;
	RET			;
;
; (SUCESS)
;
; GETS NEXT CHAR FROM SEARCH TABLE. TABLE
; "KEYWDS" AND "OPCODS" ARE CONFIGURED
; AS PACKED ASCII CHARACTERS IN WICH
; EACH CHARACTER = ASCII -41H, PACKED INTO FIVF
; REGISTER USAGE:
; A - RETURNED SEARCH CHARACTER
; B - INDEX7...COUNTER MOD 7 FOR FIVE BIT CHARACTERS.
; C - RETURNED INDEX OF KEY WORD
; D - BYTE 0 OF SEARCH WORD
; E - BYTE 1 OF SEARCH WORD
; HL-> SOURCE (MAINTENED)
; IY- TABLE POINTER (INDEX4)
;
GET5:	LD	D,(IY+0)	; GET BYTE 0 OF SEARCH WORD
	LD	E,(IY+1)	; GET BYTE 1 OF SEARCH WORD
	LD	A,B		; GET INDEX 7
;
; CHECK INDEX 7 TO SEE WHAT TO DO
;
	CP	1		;
	JR	C,I0		; INDEX7=0
	JR	Z,I1		; INDEX7=1
	CP	3		;
	JR	C,I2		; INDEX7=2
	JR	Z,I3		; INDEX7=3
	CP	5		;
	JR	C,I4		; INDEX7=4
	JR	Z,I5		; INDEX7=5
	CP	7		;
	JR	C,I6		; INDEX7=6
;
; ELSE INDEX7 =7
;
	LD	B,-1		; REINITIALIZE INDEX 7 MOD
	JR	IND4		; GO INCREMENT BYTE COUNTER
;
I0:	RRC	D		; RIGHT ROTATE D
I5:	RRC	D		;
I2:	RRC	D		;
	JR	IND7		; TO INCREMENT INDEX 7
;
I3:	SLA	E		;
	RL	D		;
I6:	SLA	E		;
	RL	D		;
I1:	SLA	E		;
	RL	D		;
I4:	SLA	E		;
	RL	D		;
IND4:	INC	IY		; INCR BYTE INDEX
IND7:	INC	B		; INCREMENT INDEX 7
	LD	A,D		; GET CHARACTER IN ROUGH
	AND	1FH		; GET 5 LSB'S
	CP	1AH		; CHECK FOR DELIMITERS
	JR	C,IND8		; NO SKIP
	ADD	A,0CH		; ELSE CONVERT TO ASCII
;
; THIS TAKES CARE OF ASCII 26H-2AH FOR & ' ( ) *
;
	JR	IND9		;
;
IND8:	ADD	A,41H		; CONVERT TO ASCII
IND9:	LD	D,A		; SAVE IT
	RET			; A,D= SEARCH CHARACTER
;
; INSTRUCTION DECODE ROUTINE
;
DEFBIX	.EQU	188		; DEFB INDEX IN OBTABL
;
INSTID:	LD	A,(IX+ERRCOD)	; GET ERROR CODE
	AND	A		; ANY CHKERR
	JR	Z,INST1		; NO ERRORS SKIP?
	CP	MLTDEF		; CHECK FOR MULTIPLE DEFINITION
	RET	NZ		;
;
; IF MULTIPLE DEFINITION, CONTINUE TO CHECK FOR
; DEFL OPCODE.
;
INST1:	LD	A,(IX+OPC)	; GET OPCODE INDEX
	CP	NULL		; NULL?
	RET	Z		;
;
; ONE BYTE OPCODE WITH NO OPERANDS?
;
	CP	NOPOPS		;
;
; NO OPERANDS?
;
	JR	NC,NOTONE	; NO SKIP FOR REG ADR
;
; ONE BYTE OPCODE WITH NO OPERANDS PROCESSING
;
	LD	A,(IX+OP1)	; CHECK FOR NO OPERANDS
	CP	NULL3		; NULL?
	JR	NZ,BADOP	; INVALID OPERAND
	LD	B,1		; OP LENGTH = 1
	LD	(IX+OPTYPE),B	;
	JP	LDSIZE		; GO LOAD SIZE
;
; SET UP SEARCH LIMITS FROM TSP
;
NOTONE:	SUB	NOPOPS		; ACCESS TSP FROM START
	LD	C,A		; PUT INDEX INTO BC
	LD	B,0		;
	LD	HL,TSP		; HL -> TSP
	ADD	HL,BC		; ACCESS "START OF SEARCH"
	LD	C,(HL)		; START OF SEARCH
	LD	IY,OPTABL	; IY -> OPTABL
	ADD	IY,BC		; IY -> INDEX INTO OPTABL
	ADD	IY,BC		; TWICE FOR CORRECT INDEX
	INC	HL		;
	LD	A,(HL)		; ACCESS "END OF SEARCH"
	SUB	C		; "END" - "START"
	LD	B,A		; SAVE IN B FOR COUNTER
	PUSH	IY		;
	PUSH	BC		; SAVE CNUNTER AND PTR
;
;  SEARCH FOR OPERAND COMBINATIONS IN OPTABL
;
	LD	E,(IX+OP2)	; GET OPERAND 2
ALOOP:	LD	D,(IX+OP1)	; GET OPERAND 1
ALOOP1:	POP	BC		; GET COUNTER
	POP	IY		; GET POINTER
	PUSH	IY		; AND SAVE AGAIN
	PUSH	BC		;
LOOP2:	LD	A,(IY+1)	; GET SECOND BYTE FROM TAB
	AND	3FH		; MASK OF JUNK
	LD	H,A		; SAVE IN H-REG
	CP	ANY		; ANY OPERAND ALLOWED?
	JR	Z,IMATCH	; YES SKIP OUT
;
; (OPERAND 1 CHECK FROM TABLE)
;
	LD	A,(IY+1)	; GET 2ND BYTE FROM TABLE
	LD	L,(IY+0)	; GET FIRST BYTE
	RLA			; MOVE2 MS BITS OF SECOND
	RL	L		; INTO 2 LS BITS OF 1ST BIT
	RLA			;
	RL	L		;
	LD	A,L		; MASK OFF JUNK
	AND	3FH		;
	LD	L,A		; SAVE IT
;
; CHECK OPERAND 1 AND OPERAND 2 FOR CORRECTNESS
;
; CHECK IN A LOOP UNTIL NO SWITCHING IS POSSIBLE.
; THE OPERANDS ARE CHECKED AGAINST OPTABL. IF THEY
; DO NOT MATCH UP, OPERAND  1 IS MODIFIED. IF IT
; CAN BE MODIFIED, THEN THE CHECK IS PERFORMED
; AGAIN. IF IT CANNOT BE MODIFIED, THEN OPERAND 2
; IS MODIFIED, AND THE CHECK IS TRIED
; AGAIN.
; THIS CONTINUES,UNTIL A MATCH IS FOUND OR
; NEITHER OPERAND CAN BE SUCCESSFULLY MODIFIED.
;
	LD	A,D		; CHECK OPERAND 1 FIRST
	CP	H		;
	JR	NZ,NMATCH	; IF NOT MATCH, SKIP
	LD	A,E		; ELSE CHECK FOR OPERAND 2
	CP	L		; AGAINST TABLE
	JR	Z,IMATCH	; IF MATCH, SKIP OUT
;
; OPERAND 1 AND 2 COULD NOT BE MATCHED.
; MOVE ON TO NEXT TABLE ENTRY AND TRY AGAIN
;
NMATCH:	INC	IY		; INCR POINTER
	INC	IY		;
	INC	C		; INCR INDEX COUNTER
	DJNZ	LOOP2		; LOOP FOR COUNT
;
; OPERAND 1 AND 2 COULD NOT BE
; MATCHED AGAINST THE
; OPERAND COMBINATIONS TABLE. MODIFY
; OPERAND 1 AND TRY AGAIN
;
	LD	A,D		; OPERAND 1
	CALL	SWITCH		; MODIFY IT
	LD	D,A		; SAVE IT
	JR	Z,ALOOP1	; IF SUCCESSFUL, LOOP
;
; OPERAND 1 NOT SUCCESSFULLY MODIFIED.
; MODIFY OPERAND 2 AND TRY AGAIN
;
	LD	A,E		; OPERAND 2
	CALL	SWITCH		; MODIFY IT
	LD	E,A		; SAVE IT
	JR	Z,ALOOP		; IF MODIFIED, LOOP BACK
;
; NO MATCH, INVALID OPERAND COMBINATION
;
	POP	BC		; POP REGS
	POP	IY		;
BADOP:	LD	(IX+ERRCOD),OPRERR; SET ERROR
	RET			;
;
; MATCH FOUND.  CHECK OP 1 AND 0P 2 FOR EXP TYPES.
; IF EXPRESSION OR EXPRESSION IN PARENTHESES,
; THEN MODIFY ORIGINAL OPERAND INDEX
;
IMATCH:	POP	AF		; BALANCE STACK
	POP	AF		;
	LD	A,D		; OPERAND 1
	AND	1FH		; MASK OF BIT 5
	CP	EXP		; EXPRESSION?
	JR	NZ,M2		;
M3:	LD	(IX+OP1),D	; SAVE NEW OPERAND
M2:	LD	A,E		; OPERAND 2
	AND	1FH		; MASK OF BIT 5
	CP	EXP		; EXPRESSION?
	JR	NZ,M5		;
M4:	LD	(IX+OP2),E	; SAVE NEW OPERAND
;
; ACCESS THE TYPE FROM THE TABLE ENTRY
;
M5:	LD	A,(IY+0)	; ACCESS BYTE 1
:
; ROTATE MS BYTE INTO LS BYTE
;
	RRCA			;
	RRCA			;
	RRCA			;
	RRCA			;
	AND	0FH		; GET 4 LSBITS
	LD	(IX+OPTYPE),A	; SAVE TYPE
	LD	A,C		; GET INDEX
	CP	DEFBIX		; CHECK FOR PSEUDO OP
	JR	NC,PSEUDO	; YES, SKIP
;
; INSTRUCTION...OBTAIN POINTER TO MACHINE CODE TABLES
; AND CALCULATE LENGTH MACHINE CODE INSTRUCTION
;
	LD	B,0		; ACCESS INDEX
	LD	HL,INSPTR	; INDEX INTO PTR TABLE
	ADD	HL,BC		;
	LD	A,(HL)		; GET NEW INDEX
	LD	(IX+OPC),A	; SAVE NEW INDEX
;
; CHECK NEW INDEX FOR RANGE...YIELDS NUMBER
; OF BYTES OF MACHINE CODE.
;
	LD	B,1		; SET UP LENGTH OF ONE
	CP	ONELIM		; CHECK FOR ONE BYTE OPCODE
	JR	C,LDSIZE	; YES, SKIP
	INC	B		; INCR LENGTH COUNTER
	CP	TWOLIM		; CHECK FOR TWO BYTE OPCODE
	JR	C,LDSIZE	; YES, SKIP
	INC	B		;
	CP	THRLIM		; CHECK FOR THREE BYTE OPCODE
	JR	C,LDSIZE	; YES, SKIP
	INC	B		; INCR LENGTH COUNTER
;
; MUST BE A FOUR BYTE OPCODE
;
LDSIZE:	LD	(IX+OPLEN),B	; SAVE LENGTH
	LD	C,B		; SET NEW REFERENCE COUNT
	LD	B,0		;
	LD	HL,(REFL)	;
	ADD	HL,BC		;
	LD	(LASREF),HL	; SAVE IT
	RET			;
;
; PSEUDO OP DECODING
; ENTER WITH A=INDEX OF OPCODE
;
PSEUDO:	ADD	A,24D		; GET NEW PSEUDO-OP INDEX
	LD	(IX+OPC),A	; AND SAVE IT
	LD	HL,(OP1POS)	; HL -> OPERAND 1 POSITION
	LD	DE,(OP1POS)	; DE -> OPERAND 1 POSITION
	SUB	DEFB-1		; GET READY TO CHECK
	LD	B,A		; GET MODIFIED INDEX
	DJNZ	PS1		; .BYTE?
	LD	B,1		; YES, LENGTH= 1
	JR	LDSIZE		;
;
PS1:	DJNZ	PS2		; DEFM?
	LD	A,(DE)		; GET FIRST CHARACTER
	CP	27H		; CHECK FOR STARTING QUOTE
	JR	NZ,DEFMRR	; IF NOT, ERROR
	LD	B,0		; ZERO LENGTH
	LD	HL,MSGBUF	; HL ->MSG BUFFER
	LD 	C,0FFH		; SET QUOTE FLAG
QLOOP:	CALL	QPROC		; PROCESS ASCII CHAR STRING
	JR	Z,LDSIZE	; IF DONE, SKIP OUT
	LD	(HL),A		; PUT INTO MSGBUF
	INC	HL		; INCR POINTER
	INC	B		; INCR LENGTH
	LD	A,B		; CHECK FOR MAXIMUM
	CP	64D		;
	JR	C,QLOOP		; IF NOT MAX, LOOP
;
; TOO MANY CHARACTERS OR NO QUOTE
;
DEFMRR:	LD	(IX+ERRCOD),SYNTAX
;
; DEFM ALLOWS MAXIMUM 63 CHARACTER COUNT
;
	RET
;
PS2:	DJNZ	PS3		; DEFW?
	LD	B,2		; YES LENGTH=2
	JR	LDSIZE		;
;
PS3:	DJNZ	PS4		; DEFS?
	CALL	EXPR		; EVALUATE EXPRESSION
	RET	NZ		; IF ERRORS, RETURN
	LD	BC,(REFL)	; ADD EXPR TO CURRENT PC
	ADD	HL,BC		;
	JR	REFOK		; SKIP
;
PS4:	DEC	B		; ENDIF?
	JR	Z,PS6A		; IF ENDIF, RESET IFFLAG
PS5:	DJNZ	PS6		; GLOBAL?
;
; GLOBAL CALL, LOCATE THE SYMBOL AND MARK GLOBAL
;
	LD	A,4		; GLOBAL CALL
	CALL	SYMBOL		;
	RET			;
;
PS6:	DJNZ	PS7		; IF?
	CALL	EXPR		; EVALUTATE EXPRESSION
	RET	NZ		; IF ERRORS RETURN
	SET	IFFLAG,(IX+CFLAG); PRESET IFFLAG
	LD	A,H		; CHECK FOR ZERO EXPRESSION
	OR	L		;
	RET	Z		; IF ZERO, LEAVE IT SET
PS6A:	RES	IFFLAG,(IX+CFLAG); ELSE RESET FLAG
	RET			;
;
PS7:	DJNZ	PS8		; ORG?
	CALL	EXPR		; EVALUATE EXPRESSION
	RET	NZ		; IF ERRORS RETURN
;
; SAVE VALUE AS NEW REFERENCE COUNTER REFOK
;
REFOK:	LD	(LASREF),HL	;
	RET			;
;
PS8:	DEC	B		; END WITH NO OPERAND?
	JR	Z,PS8A		; YES, SKIP
	DJNZ	PS9		; END WITH OPERAND?
	CALL	EXPR		; YES, EVALUATE IT
	LD	(EXADDR),HL	;
;
; SET END OF ASSEMBLY FLAG
;
PS8A:	SET	ENDFLG,(IX+CFLAG);
	RET			; RETURN TO CALLER
;
PS9:	SET	ASMFLG,(IX+SFLAG); SET ASSEMBLER DIRECTIVE FLAG
	DEC	B		; EJECT?
	JR	Z,EJL		; YES, SKIP
	DJNZ	PS10		; TITLE?
	LD	DE,HEADING	; DE -> HEADING BUFFER
	LD	B,HEADLN-1	; B = LENGTH OF BUFFER
LILOOP:	LD	A,(HL)		; GET INPUT CHARACTER
	CP	CR		; CR?
	JR	NZ,HFILL	; YES, SKIP TO FILL
	DEC	HL		;
	LD	A,' '		; FAKE A BLANK
HFILL:	LD	(DE),A		; PUT INTO HEADING BUFFER
	INC	HL		; INCR POINTERS
	INC	DE		;
	DJNZ	LILOOP		; LOOP FOR ALL
EJL:	LD	(IX+LINNUM),LINMAX; EJECT
	RET			; RETURN TO CALLER
;
PS10:	LD	A,(HL)		; GET OPERAND CHARACTER
	DJNZ	PS11		; LIST?
	SET	LISTON,(IX+CFLAG); DEFAULT LIST ON
	RET			;
;
PS11:	DJNZ	PS12		; NLIST?
	RES	LISTON,(IX+CFLAG); DEFAULT LIST OF
	RET			;
;
; RESET ASSEMBLER DIRECTIVE FLAG
;
PS12:	RES	ASMFLG,(IX+SFLAG);
	DJNZ	PS13		; NAME?
	LD	DE,NAMBUF	; NAME BUFFER
	LD	A,1		; CALL CODE ENTER
	CALL	SYMCHK		; GO CHECK SYMBOL
	RET			;
;
PS13:	DJNZ	PS14		; PSECT?
;
; PSECT IS ALLOWED ONLY ONCE IN A PROGRAM
;
	BIT	PSECTF,(IX+CFLAG);CHECK FLAG
	JR	Z,PSCTOK	; ALL RIGHT, SKIP
	LD	(IX+ERRCOD),PSECTR;ELSE ERROR
PSCTOK:	SET	PSECTF,(IX+CFLAG);SET FLAG
	CP	'R'		; RELATIVE? (DEFAULT)
	RET	Z		;
;
; NOT RELOCATABLE, SET ABSOLUTE FLAG
;
	SET	ABSFLG,(IX+LDFLAG)
	RET			;
;
PS14:	DJNZ	PS15		; MACR?
	BIT	MACRO,(IX+OPFLAG); MACRO OPTION?
	JR	NZ,MPROC	; YES, SKIP
;
; ELSE ABORT ERROR
;
MERR:	LD	A,MACERR	;
	JP	ABORT		;
;
; LABEL REQUIRED FOR MACRO DEFINITION BUT THIS NOT
; CHECKED HERE.
;
MPROC:	SET	MACDEF,(IX+CFLAG); SET MACRO DEFINITION SWITCH
;
; PLACE SOURCE BUFFER INTO MSGBUF FOR HOLDING AREA
; FOR MACRO PROCESSOR
;
	LD	BC,WIDTH	;
	LD	HL,SRCBUF	;
	LD	DE,MSGBUF	;
	LDIR			;
	RET			;
;
PS15:	DJNZ	PS16		; ENDM?
	BIT	MACRO,(IX+OPFLAG); MACRO OPTION?
	JR	Z,MERR		; NO, ERRROR
;
; END OF MACRO EXPANSION, CALL EXTERNAL
; SUBROUTINE MACEND TO FINISH UP
;
	CALL	MACEND
	RET
;
PS17:	DEC	B		; DEFL?
	RET	NZ		;
;
; DEFL, RESET ERROR CODE
;
	LD	(IX+ERRCOD),0	;
	JR	NXDEFL		; SKIP
;
PS16:	DJNZ	PS17		; EQU?
;
; IF ERRORS, RETURN
;
	LD	A,(IX+ERRCOD)	;
	AND	A		; CHECK FOR ZERO
	RET	NZ		; RETURN IF NOT ZERO
;
; EQU OR DEFL
;
NXDEFL:	BIT	LABFLG,(IX+SFLAG);CHECK FOR LABEL
	JR	NZ,EQUOK	; IF LABEL, THEN OK
LABNEED:LD	(IX+ERRCOD),LABREQ;ELSE ERROR
;
; LABEL REQUIRED FOR EQU OR DEFL
;
	RET			;
;
EQUOK:	SET	EQUMOD,(IX+SFLAG); SET EQUATE MODE
	CALL	EXPR		;
;
; RESET EQUATE MODE FLAG
;
	RES	EQUMOD,(IX+SFLAG);
	RET	NZ		; RETURN TO CALLER IF ERROR
;
; NO LOCATE THE SYMBOL AND REPLACE ITS VALUE
;
	PUSH	HL		;
	LD	HL,(LABPOS)	;
;
; LOCATE SYMBOL AND RETURN POSITION
;
	LD	A,0		;
	CALL	SYMBOL		;
	POP	HL		;
	RET	NZ		; RETURN IF ERRORS
	LD	(IY+7),H	; SAVE VALUE OF EQUATE
	LD	(IY+8),L	;
	LD	(VALEQU),HL	; SAVE VALUE OF EQUATE
;
; IF EXPRESSION IS RELOCATABLE, SET
; SYMBOL FLAGS FOR RELOCATABILITY
;
	RES	RELFLG,(IY+6)	; RESET SYMBOL REL FL
;
; IF SYMBOL IS EXTERNAL, SET RELFLG FOR SYMBOL
;
	LD	A,(IY+6)		;
	AND	5		;
	CP	4		;
	JR	Z,EQUREL	; EXT,SKIP
;
; IF SYMBOL IS INTERNAL, SET RELFLG FOR SOURCE
;
	CP	5		;
	JR	NZ,EQUTST	; NO, SKIP
	SET	RELFLG,(IX+SFLAG);
EQUTST:	BIT	RELFLG,(IX+SFLAG);
	RET	Z		; IF NOT SET, RETURN
EQUREL:	SET	RELFLG,(IY+6)	; ELSE SET THE FLAG
	RET			;
;
; MODIFIES OPERAND INDEX IN REG-A FOR SEARCH
; OF OPERAND COMBINATION TABLE
;
; ENTER WITH OPERAND INDEX IN A- REG...
;
; EXIT WITH MODIFIED INDEX IN A- REG.
;	ZERO - MODIFIED (SUCCESS).
;	NON- ZERO - NOT MODIFIED (FAILURE).
;
SWITCH:	EXX			; ALTERNATE REG SET
	LD	HL,SWTAB	; HL -> SWITCH TABLE
	LD	B,8		; SWLNG/2
SWLOOP:	CP	(HL)		; CHECK A AGAINST TABLE
	INC	HL		;
	JR	Z,FND		; FOUND, SKIP
	INC	HL		; GET TO NEXT ENTRY
	DJNZ	SWLOOP		; AND LOOP FOR ALL
	CP	8		; CHECK IF A >=8
	JR	NC,SEXP		; A >=8 ,SWITCH TO EXPRESS
;
; ELSE SWITCH TO EXTENDET REGISTER TYPE
;
	LD	A,REG_		;
	JR	RETPT		; AND GO RETURN
;
SEXP:	AND	20H		; GET PARENTHESES BIT
	OR	EXP		; SET AS EXPRESSION
	JR	RETPT		; GO RETURN
;
; TYPE FOUND IN TABLE, CHECK IF THIS TYPE
; IS REPEATED IN NEXT ENTRY.
; IF SO, THEN NO CHANGE AND RETURN NOT ZERO
;
FND:	CP	(HL)		; CHECK NEXT ENTRY IN TABLE
	JR	Z,SWNOT		; IF EXP OR PEXP, NOT SWITCH
	LD	A,(HL)		; GET NEW INDEX
RETPT:	CP	A		; SET ZERO FLAG
	EXX			; NORMAL REGISTER
	RET			;
;
SWNOT:	AND	A		; SET NON ZERO
	EXX			; REGULAR REGISTER
	RET			;
;
SWTAB:	.BYTE	REG_		;
	.BYTE	EREG_		;
	.BYTE	EREG_		;
	.BYTE	EXP		;
	.BYTE	IX_		;
	.BYTE	IXORIY		;
	.BYTE	IY_		;
	.BYTE	IXORIY		;
	.BYTE	PIXP_		;
	.BYTE	PIXIYP		;
	.BYTE	PIYP_		;
	.BYTE	PIXIYP		;
	.BYTE	EXP		;
	.BYTE	EXP		;
	.BYTE	PEXP		;
	.BYTE	PEXP		;
SWLNG	.EQU	$-SWTAB		;
;
; REINITIALIZES SYMBOL TABLE FOR PASS 2 BY RESETTING
; EXTFLG AND DEFIN2 FLAGS. IF OBJECT OUTPUT WAS
; SELECTED, THEN THE NAME, EXTERNAL SYMBOL, AND INTER-
; NAL SYMBOL OBJECT RECORDS ARE OUTPUT.
;
; OUTPUT MODULE DEFINITION RECORD
;
STOUT:	BIT	OBJFLG,(IX+OPFLAG); OBJECT OUTPUT?
	JR	Z,STOUT1	; NO, SKIP
	LD	E,(IX+OOCHNL)	; OBJECT OUT CHANNEL
	LD	HL,NAMBUF	; IY -> BUFFER
	LD	A,5		; RECORD TYPE
	CALL	OUTSYM		; OUTPUT SYMBOL RECORD
	LD	A,(IX+LDFLAG)	; LOAD MODULE FLAG
;
; CHANGE: 0 IF ABS, 1 IF REL
;
	XOR	1		;
	CALL	PTWDG		; OUTPUT IT
	SUB	A		; DO THE CHECKSUM
	SUB	C		;
	CALL	PACC		;
	CALL	CRLF		; CR AND LF
STOUT1:	LD	A,2		; INTERNAL SYMBOL FIRST
	CALL	SYMOUT		; OUTPUT THEM ALL
	LD	A,3		; EXTERNAL SYMBOL NEXT
	CALL	SYMOUT		; OUTPUT THEM ALL
	RET			;
;
; OUTPUT SYMBOL FOR OBJECT MODULE ACCORDING TO CALL
; CODE IN H:
; A=2, OUTPUT INTERNAL SYMBOLS
; A=3, OUTPUT EXTERNAL SYMBOLS
;
; ALL REGISTERS ARE USED
;
SYMOUT:	LD	IY,(SYMTAB)	; IY -> SYMBOL TABLE
	EX	AF,AF'		; SAVE CALLS CODE
LOOP4:	LD	A,(IY+6)	; GET SYMBOL FLAG
	CP	7FH		; CHECK FOR NULL ENTRY
	RET	Z		; IF SO, RETURN (DONE)
	AND	0100101B	; MASK TO CHECK
	EX	AF,AF'		; GET CALL CODE, SAVE FLAG
	LD	E,2		; OBJECT CHANNEL
	CP	2		; CHECK CALL CODE
	JR	NZ,EXTDO	; CHECK FOR EXTERNAL CALL
;
; INTERNAL SYMBOL PROCESSING
; CHECK FOR INTERNAL SYMBOL
;
	EX	AF,AF'		; GET FLAGS, SAVE CALL CC
	AND	0101B		;
	SUB	0101B		; CHECK FOR INTERNAL
	JR	Z,OUTIT		; INTERNAL SYMBOL, OUTPUT IT
	JR	NOTSET		; ELSE SKIP OUT
;
EXTDO:	EX	AF,AF'		; GET FLAGS, SAVE CC
	SUB	0100100B	; CHECK FOR EXT AND EXTFLAG
;
; RESET DEFIN2 BIT FOR ALL SYMBOLS
; TO ALLOWS FOR MULTIBLE PASSES OF PASS 2
;
	RES	DEFIN2,(IY+6)	;
	JR	NZ,NOTSET	; NOT EXT, SKIP OUT
	RES	FSTEXT,(IY+6)	; RESET FSTEXT
;
; OUTPUT THE SYMBOL
;
OUTIT:	BIT	OBJFLG,(IX+OPFLAG); OBJECT OUTPUT?
	JR	Z,NOTSET	; NO, SKIP OUT
	EX	AF,AF'		; GET CALL CODE
	PUSH	AF		; SAVE IT
	PUSH	IY		;
	POP	HL		; HL ->SYMBOL
	CALL	OUTSYM		; OUTPUT IT
	POP	AF		; RESTORE CALL CODE
	EX	AF,AF'		; SAVE CALL CODE
	INC	HL		; GET TO VALUE OF SYMBOL
	LD	A,(HL)		; OUTPUT VALUE OF SYMBOL
	CALL	PTWDG		;
	INC	HL		;
	LD	A,(HL)		; GET LSBYTE
	CALL	PTWDG		; OUTPUT IT
	SUB	A		; CALCULATE CHECKSUM
	SUB	C		;
	CALL	PACC		; OUTPUT CHECKSUM
	CALL	CRLF		;
NOTSET:	LD	DE,9		; PRESET INDEX
	ADD	IY,DE		; GET TO NEXT SYMBOL IN TABLE
	JR	LOOP4		; AND LOOP FOR MORE
; 
; A NULL ENTRY (7FH) IN THE TABLE
; TERMINATES THE OPERATION.
;
OUTSYM:	EX	AF,AF'		; SAVE CALL CODE
	LD	D,'$'		; OUTPUT DELIMITER
	CALL	WRCHR		;
	LD	(IX+OOCHNL),E	; SAVE OBJECT CHANNEL
;
; ACCESS SYMBOL NAME, CONVERT TO BINARY AND SUM
; BINARY CHECKSUM
;
	LD	B,3		; 3 TIMES 2 CHARS EACH IN
	LD	C,0		; ZERO CHECKSUM
LOOP3:	LD	D,(HL)		; ACCESS SYMBOL CHARACTER
	CALL	WRCHR		; WRITE IT OUT
	LD	A,D		;
	CALL	ASBIN		; CONVERT TO BINARY
	RLCA			;
	RLCA			;
	RLCA			;
	RLCA			;
	PUSH	AF		; SAVE 1ST CHAR IN BINARY
	INC	HL		; INCREMENT SYMBOL POINTER
	LD	D,(HL)		; GET NEXT CHARACTER
	INC	HL		; INCR POINTER
	CALL	WRCHR		; OUTPUT CHARACTER
	LD	A,D		;
	CALL	ASBIN		; CONVERT TO BINARY
	LD	D,A		; SAVE TEMPORARILY
	POP	AF		; GET 1ST CHARACTER (IN B
	ADD	A,D		; ADD 1ST AND 2ND CHARS
	ADD	A,C		; ADD CHECKSUM
	LD	C,A		; SAVE CHECKSUM
	DJNZ	LOOP3		; LOOP FOR 3 SETS OF 2 CHARACTERS
;
;  ACCESS AND OUTPUT RECORD TYPE
;
	EX	AF,AF'		;
;
; CONVERT, OUTPUT, AND CHECKSUM THE CALL CODE
;
	CALL	PTWDG		;
	RET			;
;
; BUILDS AND OUTPUTS ALL OBJECT CODE
;
; ALL REGISTERS ARE USED AND CHANGED EXCEPT IX.
;
B_LIM	.EQU	8		;
E_LIM	.EQU	130		;
G_LIM	.EQU	3		;
NEG_E	.EQU	126		;
NEG_N	.EQU	128		;
N_LIM	.EQU	128		;
R_LIM	.EQU	57		;
;
; CHECK FOR NULL OPCODE... NO OBJECT CODE
;
BUILD:	LD	A,NULL		;
	CP	(IX+OPC)	; CHECK OPCODE
	RET	Z		;
;
; IF THE IFFLAG IS SET, THEN NO OBJECT OUTPUT
;
	BIT	IFFLAG,(IX+CFLAG); CHECK IT
	RET	NZ		; RETURN IF SET
;
; IF ERRORS, THEN OUTPUT "OPLEN" OF ZERO AS
; OBJECT CODE
;
BERR:	LD	B,(IX+OPLEN)	; B=OPCODE LENGTH
	LD	A,(IX+ERRCOD)	; GET ERROR CODE
	AND	A		; CHECK FOR ERRORS
	JR	Z,BNOERR	; IF NO ERRORS SKIP
	LD	A,B		; GET LENGTH
	AND	A		; CHECK FOR ZERO
;
; IF ZERO LENGTH, RETURN TO CALLER
;
	RET	Z		;
BZL1:	SUB	A		; OUTPUT ZEROS
	CALL	BOUT		; AS OBJECT OUTPUT
	DJNZ	BZL1		; RETURN TO CALLER
	RET			;
;
; NO ERRORS FOUND, CHECK FOR ORG OR DEFS
;
BNOERR:	LD	A,(IX+OPC)	; GET OPCODE INDEX
	LD	H,A		; SAVE IT
	CP	ORG		; ORG?
	JR	Z,ORGFND	; YES SKIP
	CP	DEFS		; DEFS?
	JR	NZ,BNORG	; NO, SKIP
;
; ORG OR DEFS FOUND, SO FORCE OBJECT OUTPUT
; AND SET NEW START ADDRESS
;
ORGFND:	CALL	OBJOUT		; FORCE OBJECT OUTPUT
	LD	HL,(LASREF)	; GET NEW PC
	LD	(STADDR),HL	; SAVE AS STARTING ADDRESS
;
; FOR NEXT OBJECT RECORD TO BE OUTPUT
;
	RET			;
;
; IF ZERO OPCODE LENGTH, THEN NO OBJECT CODE
;
BNORG:	LD	A,B		; GET OPCODE LENGTH
	AND	A		; CHECK IT
	RET	Z		; IF ZERO, RETURN TO CALL
;
; CHECK FOR DEFM OPCODE FOR SPECIAL HANDLING
;
	LD	A,H		; GET OPCODE INDEX
	CP	DEFM		; DEFM?
	JR	NZ,BNDEFM	; NO, SKIP
;
; DEFM OPCODE HANDLING...OUTPUT FROM MSGBUF
;
	LD	HL,MSGBUF	; HL -> MSGBUF
DLOOP:	LD	A,(HL)		; GET CHARACTER TO BE OUTPUT
	CALL	BOUT		; OUTPUT IT
	INC	HL		; INCR PTR
	DJNZ	DLOOP		; LOOP FOR ALL OF THEM
	RET			;
;
; INITIALIZE VALUES AND REGISTERS FOR
; BUILDING THE OBJECT CODE
;
; A - CODONE
; B - TYPE (OPTYPE)
; C - 0 FOR IX, 20H FOR IY IN OP1 OR OP2
; D - OP1 EXPRESSION RESULT
; E - OP1 EXPRESSION RESULT + 1
; H - OP2 EXPRESSION RESULT
; L - OP2 EXPRESSION RESULT + 1
;
; A'- CODONE
; B'- CODTWO
; C'- CODFOR
; D'- OP1
; E'- OP2
; H'- OP1 SHIFTED LEFT 3
; L'- OP2 SHIFTED LEFT 2
;
; IX -> RAM
; IY -> OBJECT BUFFER*******CHECK THIS
;
; CHECK FOR AND EVALUATE OPERAND EXPRESSIONS
;
BNDEFM:	LD	DE,(OP1POS)	; OPERAND 1 POSITION
	LD	A,(OP1)		; OPERAND 1 INDEX
	CALL	BEXPV		; EVALUATE EXPRESSION
	JR	NZ,BERR		; IF ERRORS, SKIP OUT
	LD	(SAVE1),HL	; SAVE RESULT
	LD	DE,(OP2POS)	; DE -> OPERAND 2 POSITION
	LD	A,(OP2)		; A= OPERAND 2 INDEX
	CALL	BEXPV		; EVALUATE EXPRESSION
	JR	NZ,BERR		; ERROR, SKIP OUT
	LD	DE,(SAVE1)	; DE =OP1 RESULT
;
; HL = OP2 RESULT
;
	EXX			; PRIMED REGS
	LD	A,(IX+OPC)	; OPCODE INDEX
;
; INDEX INTO BYTONE TABLE TO GET CODONE
;
	LD	E,(IX+OPC)	; GET OPCODE INDEX
	LD	D,0		;
	LD	HL,BYTONE	; HL	-> BYTONE
	ADD	HL,DE		; INDEX INTO TABLE
	LD	A,(HL)		; A'=CODONE
	PUSH	AF		; SAVE CODONE
	EX	AF,AF'		; AND PUT INTO A'
	LD	A,E		; SET UP INDEX FOR BYTWO
	SUB	ONBYLM		;
	LD	E,A		; INDEX INTO IT
	LD	HL,BYTWO	;
	ADD	HL,DE		;
	LD	B,(HL)		; B'=CODWO
	SUB	FRBYLM		; SET UP INDEX FOR BYTFOR
	LD	E,A		;
	LD	HL,BYTFOR	;
	ADD	HL,DE		; INDEX INTO IT
	LD	C,(HL)		; C'=CODFOR
;
; SETS UP OTHER REGS
;
	LD	A,(IX+OP1)	; A=OP1
;
; SET NULL OPCODE EQUAL TO ZERO
;
	CP	NULL3		; CHECK FOR NULL
	JR	NZ,DOP1		; NOT NULL, SKIP
	SUB	A		; SET ZERO OP1
DOP1:	LD	D,A		; D'=OP1
	LD	H,D		;
	SLA	H		;
	SLA	H		;
	SLA	H		; H'=OP1 SHIFTED LEFT 3
	LD	A,(IX+OP2)	; A=OP2
;
; SET NULL OPERAND TO ZERO
;
	CP	NULL3		; CHECK FOR NULL
	JR	NZ,EOP2		; NOT NULL, SKIP
	SUB	A		; ELSE SET TO ZERO
EOP2:	LD	E,A		; E=OP2
	LD	L,E		;
	SLA	L		;
	SLA	L		;
	SLA	L		; L'=OP2 SHIFTED LEFT 3
	EXX			; UNPRIMED REGISTERS
	LD	B,(IX+OPTYPE)	; B=TYPE
	LD	C,(IX+IYMASK)	; GET IY MASK (0 OR 2)
	POP	AF		; A=CODONE
;
; CHECK LENGTH OF OPCODE AND BRANCH ACCORDINGLY
;
	PUSH	BC		; SAVE TYPE
	LD	B,(IX+OPLEN)	; GET LENGTH
	DEC	B		; ONE BYTE OPCODE?
	JR	Z,ONE		; YES, SKIP
	DEC	B		; TWO BYTE OPCODE?
	JR	Z,TWO		; YES, SKIP
	DEC	B		;
	JP	Z,THREE		; THREE BYTES
	DEC	B		;
	JP	Z,FOUR		; FOUR BYTES
	RET			;
;
; DECODE AND SET UP 1 BYTE CODES
;
ONE:	POP	BC		;
	DJNZ	ONE2		; TYPE =1?
;
; YES, FALL THROUGH THE REST
;
ONE2:	DJNZ	ONE3		; TYPE=2?
	EXX			;
	ADD	A,E		; CODONE+OP2+OP1S3
	ADD	A,H		;
	EXX			;
ONE3:	DJNZ	ONE4		; TYPE =3?
	EXX			;
	ADD	A,D		; CODONE +OP!
	EXX			;
ONE4:	DJNZ	ONE5		; TYPE =4?
	EXX			; YES
	ADD	A,E		; CODONE+OP2
	EXX			;
ONE5:	DJNZ	ONE6		; TYPE =5
	LD	A,E		; OP1RES LS BYTE
	JR	LDONE		;
;
ONE6:	DJNZ	LDONE		; TYPE=6?
	EX	DE,HL		;
	LD	BC,0		; CHECK LIMITS
	LD	DE,R_LIM	; OF OP1 EXPRESSION
	CALL	LIMIT		;
	LD	A,L		; OP1RES
	AND	7		; CHECK RANGE
	JR	Z,ONE6A		;IF OK, SKIP
	LD	(IX+ERRCOD),RNGERR; ELSE RANGE ERRROR
ONE6A:	EX	AF,AF'		; CODONE
	ADD	A,L		; CODONE+OP1RES
	JR	LDONE		;
;
LDTWO:	CALL	BOUT		; OUTPUT FIRST BYTE
	LD	A,B		; OUTPUT SECOND BYTE
LDONE:	CALL	BOUT		; LOAD ONE BYTE
	RET			;
;
TWO:	POP	BC		; DECODE TWO BYTE INSTS
	DJNZ	TWO2		; TYPE=1?
	ADD	A,C		; CONDONE+IYMASK
	EXX			; CODTWO
	JR	LDTWO		; OUTPUT CODONE & CODTWO
;
TWO2:	DJNZ	TWO3		; TYPE=2?
	EXX			; YES
	ADD	A,H		; CODONE +OP1S3
	EXX			; UNPRIMED REGS
TWO2A:	LD	B,L		; OP2RES LS BYTE
	JR	LDTWO		;
;
TWO3:	DJNZ	TWO4		; TYPE=3?
	JR	TWO2A		; GO DC BYTE2=OP2RES
;
TWO4:	DJNZ	TWO5		; TYPE=4?
	EXX			; YES
	LD	A,B		; CODTWO+OP1
	ADD	A,D		;
TWO4A:	LD	B,A		;
	EX	AF,AF'		; CODONE
TWO4C:	JR	LDTWO		;
;
TWO5:	DJNZ	TWO6		; TYPE=5?
;
; CHECK OP1RES RANGE		;
;
	EX	DE,HL		;
	LD	BC,0		;
	LD	DE,B_LIM	;
	CALL	LIMIT		;
	SLA	L		; OP1RES SHIFT LEFT 3
	SLA	L		;
	SLA	L		;
	LD	A,L		;
	EXX			; CODTWO+OP1RES/s3
	ADD	A,B		; +OP2
	ADD	A,E		;
	JR	TWO4A		; FINISH IT
;
TWO6:	DJNZ	TWO7		; TYPE=6?
	LD	B,E		; OP1RES
	JR	LDTWO		;
;
TWO7:	DJNZ	TWO8		; TYPE=7?
	EXX			;
	LD	A,B		; CODTWO+OP2S3
	ADD	A,L		;
	JR	TWO4A		; FINISH IT
;
TWO8:	DJNZ	TWO9		; TYPE=8?
	EXX			; YES
	LD	A,B		; CODTWO+OP1S3
	ADD	A,H		;
	JR	TWO4A		; FINISH IT
;
TWO9:	DJNZ	TWO10		; TYPE=9?
	EX	DE,HL		;
	LD	BC,0		;
	LD	DE,G_LIM	;
	CALL	LIMIT		;
	LD	A,L		;
	AND	A		;
	JR	Z,TWO9A		; IF ZERO, SKIP
	INC	A		; INCREMENT IT
	RLCA			; ELSE SHIFT LEFT 3
	RLCA			;
	RLCA			;
TWO9A:	EXX			; PRIMED REGS
	ADD	A,B		; CODTWO+OP1RES S3
	LD	B,A		;
	JR	TWO4A		; AND FINISH IT
TWO10:	DJNZ	TWO11		; TYPE=10?
	LD	A,E		; OP1RES
	LD	B,D		; OP1RES+1
	CALL	ROUT		; OUTPUT RELOCATION INFO
	JR	TWO4C		; GO TO LDTWO
;
TWO11:	DJNZ	TWO12		; TYPE=11?
	EX	DE,HL		; HL=OP1RES
TWO12:	LD	DE,E_LIM	; TYPE=12
	LD	BC,NEG_E	; CHECK LIMITS OF OP2RES
	CALL	LIMIT		;
	LD	B,L		;
	DEC	B		; OP2RES-2
	DEC	B		;
	JR	TWO4C		; GO TO LDTWO
;
THREE:	POP	BC		; THREE BYTES DECODE
	DJNZ	THR2		; TYPE=1?
	ADD	A,C		; CODONE+IY INDEX, 1ST BY
	EX	AF,AF'		;
	CALL	LIMITA		;
	LD	C,L		; 3RD BYTE
	EXX			; PRIMED REGS
	LD	A,B		; CODTWO+OP1S3
	ADD	A,H		;
	JR	THR2A		; GO FINISH IT
;
THR2:	DJNZ	THR3		; TYPE=2?
	ADD	A,C		; 1 ST BYTE=CODONE+IY INDEX
	EX	AF,AF'		; SAVE IT
	EX	DE,HL		; CHECK LIMITS OF OP1 EXPRESSION
	CALL	LIMITA		;
	LD	C,L		; 3 RD BYTE=OP1 EXPRESSION
	EXX			; PRIMEDS REGS
	LD	A,B		;
	ADD	A,E		; CODTWO+OP2
THR2A:	EXX			;
	LD	B,A		; 2 ND BYTE
	JR	THR6B		; GO EX AF,AF' AND FINISH
;
THR3:	DJNZ	THR4		; TYPE=3?
	ADD	A,C		; 1 ST BYTE=CODONE+IY INDEX
	LD	B,L		; 2 ND=OP2 EXPRESSION
	LD	C,H		; 3 RD=OP2 EXPR MSB
	JR	THR4A		; GO ROUT AND FINISH
THR4:	DJNZ	THR5		; TYPE=4?
	LD	B,E		; 2 ND=OP1 EXPR
	LD	C,D		; 3 RD=OP1 EXPR MSB
THR4A:	CALL	ROUT		; OUTPUT RELOCATION INFO
	JR	LDTHR		;
;
THR5:	DJNZ	THR6		; TYPE=5?
	JR	THR6A		; SKIPPO TO DO OP2 EXPR
;
THR6:	EX	DE,HL		; CHECK OP1 EXPR RANGE
THR6A:	ADD	A,C		; CODONE+IYMASK
	EX	AF,AF'		; SAVE IT
	CALL	LIMITA		;
	LD	A,L		;
	EXX			;
	LD	C,A		; 3RD BYTE=OP2 EXPR
THR6B:	EX	AF,AF'		; RESTORE 1ST BYTE
;
LDTHR:	CALL	BOUT		; OUTPUT 1ST BYTE
	LD	A,B		;
	CALL	BOUT		; :ND BY\E
	LD	A,C		;
	CALL	BOUT		; 3ND BYTE
	RET			;
;
FOUR:	POP	BC		; FOUR BYTE DECODE
	DJNZ	FOUR2		; TYPE=1?
	ADD	A,C		; CODONE+IY INDEX
	EX	AF,AF'		; SAVE IT
	EX	DE,HL		; CHECK OP1 EXPR LIMITS
	PUSH	DE		; SAVE OP1
	CALL	LIMITA		;
	LD	A,L		; 3RD BYTE=OP1 EXPR
	EXX			;
	LD	C,A		;
;
; B' = SECOND BYTE
;
	POP	DE		; POP FOURTH BYTE=OP2 EXPR
	LD	D,E		;
	JR	FOUR4A		;FINISH IT
;
FOUR2:	DJNZ	FOUR3		; TYPE=2?
	PUSH	HL		; SAVE OP2 EXPR
	JR	FOUR5A		;GO DO OP2 EXPR
;
FOUR3:	DJNZ	FOUR4		; TYPE=3?
	ADD	A,C		; CODONE+IY INDEX
	EX	AF,AF'		; SAVE IT
	LD	A,E		; OP1RES
	EXX			;
	LD	D,C		;
	LD	C,A		;
	JR	FOUR4A		; GO EX AF,AF' AND FINISH
;
FOUR4:	DJNZ	FOUR5		; TYPE=4?
	ADD	A,C		; CODONE+IY INDEX
	EX	AF,AF'		; SAVE IT
	PUSH	DE		;
	CALL	LIMITA		;
	POP	DE		;
	EX	DE,HL		; OP1 EXPR CHECK
	PUSH	DE		; CHECK LIMIT
	LD	BC,0		;
	LD	DE,B_LIM	;
	CALL	LIMIT		;
	SLA	L		;
	SLA	L		;
	SLA	L		; SHIFT OP1 EXPR LEFT 3
	LD	A,L		;
	EXX			;
	ADD	A,C		; CONFOR+OP1 EXPR S3
	LD	D,A		;
	POP	HL		; OP2 EXPR
	LD	C,L		;
FOUR4A:	EX	AF,AF'		; RESTORE 1ST BYTE
	JR	LDFOR		;
;
FOUR5:	PUSH	DE		; SAVE DE REGS
FOUR5A:	ADD	A,C		; CODONE+IYMASK
	EXX			;
	POP	HL		; 4TH=OP1 EXPR
	LD	C,L		;
	LD	D,H		;
	CALL	ROUT		; OUTPUT RELOCATION INFO
;
LDFOR:	CALL	BOUT		; OUTPUT 1ST BYTE
	LD	A,B		; 2ND BYTE
	CALL	BOUT		;
	LD	A,C		; 3RD BYTE
	CALL	BOUT		;
	LD	A,D		; 4TH BYTE
	CALL	BOUT		;
	RET			;
;
; EXPRESSION EVALUATION FOR BUILD ROUTINE
; ENTRY: A=OPERAND INDEX
;        DE -> OPERAND POSITION IN SOURCE CODE
;
BEXPV:	CP	PIXIYP		; IX OR IY PLUS DISPLACEMENT
	JR	Z,BEXP		; YES, SKIP
	AND	1FH		; MASK OFF BIT 5
	CP	EXP		; EXPRESSION?
	JR	Z,BEXP		; YES, SKIP
	AND	A		;
	SBC	HL,HL		;
	RET			;
;
BEXP:	CALL	EXPR		; EVALUATE EXPRESSION
	RET			; RETURN ERROR INDICATOR
;
LIMITA:	LD	BC,NEG_N	; SET UP LIMITS
	LD	DE,N_LIM	;
LIMIT:	PUSH	HL		; SAVE HL
	BIT	7,H		; IS H MINUS?
	JR	Z,POSTST	; NO, SKIP
	ADD	HL,BC		; YES, AND LOWER LIMIT
	BIT	7,H		; IT IS MINUS, NOW?
	POP	HL		; RESTORE HL
	RET	Z		; IF OT MINUS, OK,RETURN
LIMERR:	LD	(IX+ERRCOD),RNGERR; ELSE RANGE ERROR
	RET			;
;
POSTST:	SBC	HL,DE		; CHECK UPPER LIMIT
	POP	HL		; RESTORE HL
	JR	NC,LIMERR	; IF NO CARRY, OK
	RET			;
;
SOUT	.EQU	0D9B0H		; LOCATED IN EDITOR
;
; 'SOUT' IS THE TEXT EDITOR STRING OUTPUT ROUTINE
;
; OUTPUT ASSEMBLY LISTING, LINE BY LINE
; COUNT LINES AND EJECT PAGES WHERE REQUIRED
;
; CHECK IF AN EXTERNAL REFERENCE IS
; ALLOWED FOR THIS OPCODE. IF AN EXTERNAL
; REFERENCE WAS FOUND, THEN ERROR
;
LIST:	LD	C,(IX+SFLAG)	; GET SFLAG
	LD	B,(IX+CFLAG)	; GET CONTROL FLAG
	BIT	EXTOK,C		; IS EXT REF ALLOWED?
	JR	NZ,EREFOK	; YES, OK SKIP
;
; EXTERNAL REFERENCE NOT ALLOWED,
; SO CHECK IF THERE IS ONE
;
	BIT	EXTFLG,C	; EXT REF?
	JR	Z,EREFOK	; NO, OK, SKIP
;
; ELSE ERROR
;
	LD	(IX+ERRCOD),EXTEXP; EXTERNAL REF ERROR
;
; IF PASS 1, DO NOT OUTPUT ASSEMBLY LISTING
;
EREFOK:	BIT	PASS2,(IX+OPFLAG); OPERATIONS FLAG
	RET	Z		; RETURN IF PASS 1
;
; SET UP SOURCE OUTPUT CHANNEL
;
	LD	E,(IX+SOCHNL)	; SOURCE OUTPUT
;
; IF MACRO EXPANSION, DO NOT INCREMENT STATEMENT
;
	BIT	MACEXP,B	; EXPANSION?
	JR	NZ,CHKERR	; YES, SKIP
;
; ELSE INCREMENT STATEMENT NUMBER
;
	LD	HL,(STMENT)	;
	CALL	BCDINC		;INCR IN BCD FORM
	LD	(STMENT),HL	;
CHKERR: LD	A,(IX+ERRCOD)	; CHECK FOR ERRORS
	BIT	LISTING,(IX+OPFLAG); OPERATION FLAG
	JR	NZ,LSTERR	; IF LISTING, SKIP
;
; IF NO LISTING, OUTPUT ERRORS ON CONSOLE DEVICE
;
	LD	E,0		; CONSOLE CHANNEL
	AND	A		; CHECK FOR ERRORS
	RET	Z		; RETURN IF NO ERRORS
LSTERR:	AND	A		; CHECK FOR ERRORS
	JR	NZ,ELIST	; IF ERRORS, FORCE PRINT
;
; IF ASSEMBLER DIRECTIVE, DO NOT LIST
;
	BIT	ASMFLG,C	;
	RET	NZ		;
;
; IF LISTING OFF, DO NOT LIST
;
	BIT	LISTON,B	;
	RET	Z		;
ELIST:	PUSH	AF		; SAVE ERROR CODE
	CALL	NXTLIN		; GET NEXT LINE NBR
	POP	AF		; CHECK ERROR CODE
	AND	A
	LD	D,' '		; SET BLANK FOR PRINTOUT
	JR	Z,EP		; IF NO ERRORS, SKIP
	LD	D,A		; ELSE PRINT ERROR CODE
	LD	HL,(ERRNBR)	; INCR NBR OF ERRORS
	CALL	BCDINC		;
	LD	(ERRNBR),HL	;
EP:	CALL	WRCHR		; WRITE OUT BLANK OR CODE
	CALL	SPACE		; AND A BLANK
;
; CHECK FOR CONDITIONAL ASSEMBLY
;
	BIT	IFFLAG,B	; CONTROL FLAG
	JR	NZ,L14B		; IF SO, SKIP CODE LIST
;
; CHECK FOR EQU, DEFL, OR NULL OPCODE
;
	LD	A,EQUTYP-1	;
	CP	(IX+OPC)	; CHECK OPCODE INDEX
	JR	NC,LNONX	; IF NOT, SKIP
;
; EQU DEFL, OR NULL OPCODE, CHECK FOR LABEL
;
	BIT	LABFLG,C	;
	JR	Z,L14B	;IF NO LABEL OUTPUT BLKS
;
; LABEL FOUND FOR EQU, DEFL, OR NULL OPCODE
; CONVERT AND OUTPUT EQUATE VALUE
;
	BIT	RELFLG,C	; RELOCATABLE?
	CALL	PADDLE		; CHECK FOR RELOCATABLE
	LD	D,'>'		; OUTPUT A POINTER
	CALL	WRCHR		;
	LD	HL,(VALEQU)	; GET VALUE
	CALL	PADDO		; CONVERT AND OUTPUT
	LD	B,10		; SET FOR BLANKS
	JR	LSPACE		; AND SKIP OUT
;
; CHECK FOR NON-CODE OPCODE
;
LNONX:	LD	A,(IX+OPC)	; OPCODE INDEX
	CP	NONOPS		; NON CODE OPCODE?
	JR	NC,L14B		;IF SO, SKIP CODE LIST
;
; CONVERT AND OUTPUT PROGRAM COUNTER
; CHECK FOR RELOCATABLE ADRESS (PROGRAMM COUNTER)
; ZERO FLAG MUST NOT BE SET UPON ENTRY HERE
;
	CALL	PADDLE		; CHECK ABSFLG
	LD	HL,(REFL)	;
	CALL	PADDO		;
;
; CHECK IF ANY OBJECT CODE TO BE OUTPUT
;
	LD	A,(IX+OPLEN)	; LENGTH OF OPCODE
	LD	B,11		; PRESET BLANK COUNTE
	AND	A		;
	JR	Z,LSPACE	; NO, SKIP OUT
;
; LENGTH > 0, OUTPUT THE CODE
;
	CALL	SPACE		; OUTPUT SPACE
	LD	HL,LBUF		; HL -> HOLDING BUFFER
LCODB:	LD	C,(IX+LCOUNT)	; COUNT INTO B AND C
	LD	B,C		;
LCODL:	LD	A,(HL)		; GET BYTE OF OBJECT CODE
	CALL	PACC		; CONVERT AND OUTPUT
	INC	HL		; INCR POINTER
	DJNZ	LCODL		; LOOP FOR ALL
	BIT	LRLFLG,(IX+SFLAG); CHECK LISTING R
	CALL	PADDLE		; CHECK FOR RELOCATABLE
;
; WRITE OUT BLANKS TO FILL THE LINE
;
	LD	A,4		;
	SUB	C		;
	AND	A		;
	RLCA			; MULTIPLY BY 2
	INC	A		; INCR FOR THE ODD BLANK
	LD	B,A		; SET COUNTER
	JR	LSPACE		; AND GO DO IT
;
; OUTPUT REST OF LINE
;
L14B:	LD	B,17		; SET BLANKS
LSPACE:	CALL	SPACE		; OUTPUT A BLANK
	DJNZ	LSPACE		; LOOP FOR B COUNT
STNUM:	LD	(IX+SOCHNL),E	; UPDATE CHANNEL NBR
	LD	D,'+'		; SET A PLUS FOR MACRO EXPANSION
	BIT	MACEXP,(IX+CFLAG); CHECK FOR MACRO
	CALL	NZ,WRCHR	; MACRO EXP, OUTPUT A PLUS
; NOTE: THIS OFFSETS THE EXPANSION IN THE LISTING.
	LD	HL,(STMENT)	; OUTPUT STATEMENT NBR
	CALL	PADDO		;
;
; OUTPUT THE SOURCE LINE
;
LSRC:	LD	HL,SRCBUF	; HL -> SOURCE BUFFER
;
; STRIP PARITY FROM SOURCE BUFFER
;
	PUSH	HL		;
	LD	B,WIDTH		; MAXIMUM WIDTH
RPLOOP:	RES	7,(HL)		;
	INC	HL		;
	DJNZ	RPLOOP		; LOOP FOR ALL
	POP	HL		; RESTORE SOURCE PTR
	CALL	SOUT		; STRING OUT WITH TABS
;
; ABOVE ROUTINE IS IN THE EDITOR.
;
	RET			;
;
PADDLE: LD	D,' '		; PRESET A BLANK
	JR	Z,PAD1		; IF ENTRY TEST ZERO, SKIP
	BIT	ABSFLG,(IX+LDFLAG); ABSOLUTE ASSEMBLY
	JR	NZ,PAD1		; YES, SKIP
	LD	D,27H		; NO PUT IN A QUOTE
PAD1:	CALL	WRCHR		; OUTPUT BLANKS OR QUOTE
	RET			;
;
; INCREMENTS AND CHECKS LINE NUMBER
; AND EJECTS PAGE AND PRINTS HEADING IF
; REQUIRED.
;
; ENTRY: E=DECICE CODE
;
; CHECK CURRENT LINE NUMBER
;
NXTLIN:	PUSH	HL		; SAVE HL REGISTER
	LD	A,(IX+LINNUM)	; GET CURRENT LINE #
	INC	A		; INCR IT
	CP	LINMAX		; CHECK AGAINST MAX
	JR	C,LINNXT	; IF NOT MAX, SKIP
;
; MAX LINE # REACHED. EJECT PAGE, OUTPUT HEADING
;
	LD	HL,EJMES	; HL ->EJECTS
	CALL	PTXT		; OUTPUT THEM
;
; SET HL -> NAME AND USER HEADING.
;
	LD	HL,NAMBUF	; HL -> USER HEADING
	CALL	PTXT		; OUTPUT IT
	LD	HL,HD2MSG	; 2ND HEADING
	CALL	PTXT		; OUTPUT IT
	SUB	A		; ZERO LINE COUNTER
LINNXT:	LD	(IX+LINNUM),A	; UPDATE LINE NUMBER
	POP	HL		; RESTORE HL-REG FOR CALL
	RET			;
;
EJMES:	.BYTE	0AH		; LINE FEED
	.WORD	0A0AH		; FOUR LINE FEEDS
	.WORD	0A0AH		;
	.BYTE	03H		; ETX ENDS MESSAGE
;
HD2MSG:	.WORD	0A0DH		; CR,LF
	.BYTE	"   ADDR  OBJECT    ST #"
	.WORD	0A0DH		; CR,LF
	.BYTE	0AH		; EXTRA LF
	.BYTE	03H		; TERMINATOR
;
; PRINT OUT SYMBOL TABLE IF REQUESTED
;
; CHECK OPERATIONS FLAG
;
STP:	BIT	SYMFLG,(IX+OPFLAG); TABLE REQUESTE
	RET	Z		; NO, RETURN
;
; FORCE PAGE EJECT NEXT TIME
;
	LD	(IX+LINNUM),LINMAX; MAXIMUM LINE NBR
	LD	IY,(SYMTAB)	; HL -> SYMBOL TABLE ST
;
; DO I=0 TO SYMPTR
;
LOOP1:	LD	E,(IX+SOCHNL)	; SOURCE OUTPUT CHANNEL
	LD	A,(IY+6)	; ANY LEFT?
	CP	7FH		; IF NULL, NOPE
	RET	Z		; IF NULL, DONE, RTURN
	CALL	NXTLIN		; INCR LINE NBR AND CHECK
	CALL	CRLF		; CR AND LF
	LD	C,4		; # OF SYMBOL PER LINE
BLOOP2:	PUSH	IY		; PUT POINTER INTO HL
	POP	HL		;
	LD	A,(IY+6)	; CHECK FOR ANY LEFT
	CP	7FH		; IF NULL, ALL DONE
	RET	Z		;
	LD	B,6		; CHARACTERS PER SYMBOL
	LD	E,4		; SOURCE OUTPUT CHANNEL
STPSYM:	LD	D,(HL)		; GET SYMBOL CHARACTER
	CALL	WRCHR		; WRITE IT OUT
	INC	HL		; INCR PTR
	DJNZ	STPSYM		; LOOP FOR ALL CHARACTERS
	LD	B,7		; PREPARE BLANKS COUNTER
	LD	A,(HL)		; INTERNAL SYMBOL?
	LD	HL,INTMSG	; PRELOAD HL PTR
	AND	5		; MASK BIT
	CP	5		; CHECK FOR INTERNAL
	JR	Z,PUTFLG	; YES, OUTPUT FLAG
	BIT	2,A		; CHECK FOR EXTERNAL
	JR	Z,S5		; NOPE, OUTPUT BLANKS
	LD	HL,EXTMSG	; HL -> EXTERNAL FLAG
PUTFLG:	CALL	PTXT		; OUTPUT TEXT
	LD	B,1		; ONE BLANK ONLY
S5:	CALL	SPACE		;
	DJNZ	S5		; LOOP FOR ALL
VALUE:	LD	H,(IY+7)	; GET VALUE FOR PRINT OUT
	LD	L,(IY+8)	;
	CALL	PADDO		; PRINT OUT VALUE AFTER C
	LD	DE,9		; INCR POINTER TO NEXT SYMBOL
	ADD	IY,DE		;
	DEC	C		; DECR COUNTER FOR SYMBOL
	JR	NZ,BLOOP2	; IF NOT DONE, LOOP FOR
	JR	LOOP1		; LOOP UNTIL DONE
;
INTMSG:	.BYTE	" [INT]"	;
	.BYTE	03H		;
;
EXTMSG:	.BYTE	" [EXT]"	;
	.BYTE	03H		;
;
; CONVERTS AND OUTPUTS OBJECT OUTPUT BUFFER
;
; IF ZERO COUNTS,
; THEN RETURN TO CALLER (NO OUTPUT)
;
OBJOUT:	LD	A,(IX+OCOUNT)	;
	AND	A		;CHECK IT
	RET	Z		;
ETXOUT:	BIT	OBJFLG,(IX+OPFLAG); CHECK OBJECT O
	RET	Z		;
	LD	D,':'		; OUTPUT RECORD MARK
	LD	E,(IX+OOCHNL)	; OBJECT CHANNEL
	CALL	WRCHR		; WRITE IT OUT
	LD	(IX+OOCHNL),E	; SAVE UPDATED CHANNEL
	LD	C,0		; ZERO CHECKSUM
	LD	A,(IX+OCOUNT)	; GET BYTE COUNT
	LD	B,A		;
	CALL	PTWDG		; CONVERT TO ASCII,
;
; OUTPUT IT, AND SUM BINARY CHECKSUM
;
	LD	A,(IX+STADDR+1)	; ACCES START ADRESS H
	CALL	PTWDG		; CONVERT AND OUTPUT AND
	LD	A,(IX+STADDR)	; ACCESS START ADDRESS L
	CALL	PTWDG		; CONVERT AND OUTPUT AND
	LD	A,B		; CHECK FOR ZERO COUNT
	AND	A		;
	JR	Z,BEOT		;
	SUB	A		; OUTPUT ZERO
	LD	HL,OBUF		; HL -> BUFFER TO BE OUTPUT
	LD	(OPOINT),HL	; REINIT POINTER
	CALL	DOCTOR		; OUTPUT IT
;
; REINIT
;
	LD	C,(IX+OCOUNT)	; INCREMENT START ADDRESS
;	LD	B,0		;
	LD	(IX+OCOUNT),B	; REINIT COUNTER
	LD	HL,(STADDR)	;
	ADD	HL,BC		;
	LD	(STADDR),HL	; SAVE NEW START ADDRESS
	RET			;
;
BEOT:	INC	A		; OUTPUT A ONE
	CALL	PTWDG		;
	JP	EOTDOC		; OUTPUT REST OF IT
;
; IF PASS 1, DO NOT OUTPUT OBJECT CODE
;
BOUT:	BIT	PASS2,(IX+OPFLAG); OPERATIONS FLAG
	RET	Z		; RETURN IF PASS1
;
; PLACES CONTENTS OF A-REG INTO OBJECT OUTPUT BUFFER
; CALLS OBJOUT WHEN 16 BYTES HAVE BEEN PLACED.
; BYTES ARE STORED AS BINARY AND CONVERTED
; BY OBJOUT UPON OUTPUT
;
	EX	AF,AF'		; SAVE BYTE
	EXX			; ALTERNATE REGISTERS
;
; CHECK FIRST OBJECT BYTE FLAG
;
	BIT	FSTOBJ,(IX+OPFLAG);
	JR	NZ,NOBJF	; NOT FIRST, SKIP
;
; FIRST BYTE OF OBJECT CODE. SAVE
; PROGRAM COUNTER FOR TRANSFER ADDRESS
;
	LD	HL,(REFL)	; SET PROGRAM COUNTER
	LD	(EXADDR),HL	; SAVE AS TRANSFER ADDRESS
	SET	FSTOBJ,(IX+OPFLAG); SET FLAG
;
; SET UP CODE BUFER FOR LISTING OUTPUT
;
NOBJF:	LD	A,(IX+LCOUNT)	; GET COUNT
	CP	4		; CHECK FOR >4
	JR	NC,NOLOBJ	; IF >=4, SKIP
	EX	AF,AF'		; GET BYTE
	LD	HL,(LPOINT)	; HL -> LISING BUFFER
	LD	(HL),A		; SAVE BYTE IN BUFFER
	INC	HL		; INCR POINTER
	LD	(LPOINT),HL	; SAVE POINTER
	INC	(IX+LCOUNT)	; INCR COUNTER
;
; CHECK IF OBJECT OUTPUT IS REQURED
;
	BIT	OBJFLG,(IX+OPFLAG)
	JR	Z,RRETPT	; IF NOT, SKIP OUT
	EX	AF,AF'		; SAVE BYTE
NOLOBJ:	LD	A,(IX+OCOUNT)	; CHECK IT
	BIT	5,A		; IS IT 32 YET?
	CALL	NZ,OBJOUT	; IF SO, OUTPUT BUFFER
	INC	A		; INCR COUNT
	LD	(IX+OCOUNT),A	; REINIT POINTER
	LD	HL,(OPOINT)	; HL->OBJECT BUFFER
	EX	AF,AF'		; RESTORE BYTE
	LD	(HL),A		; PUT BYTE INTO BUFFER
	INC	HL		; INCR POINTER
	LD	(OPOINT),HL	; SAVE IT
RRETPT:	EXX			; NORMAL REGISTER
	RET			;
;
; OUTPUT RELOCATION RECORD FROM RELOCATION BUFFER
;
RELOUT:	CALL	OBJOUT		; OUTPUT ANY OBJECTCODE
	LD	A,(IX+RCOUNT)	; GET RELOCATION BYTE
	AND	A		; CHECK FOR ZERO
	RET	Z		; IF ZERO, RETURN
	LD	B,A		; PUT COUNT INTO B
	LD	DE,2402H	; D='S' , E= OBJECT CHNL
	CALL	WRCHR		; OUTPUT RECORD DELIMITER
	LD	C,0		; ZERO CHECKSUM
	LD	(IX+RCOUNT),C	; ZERO COUNT
	LD	A,B		; GET BYTE COUNT
	CALL	PTWDG		; OUTPUT BYTE COUNT
;
; OUTPUT 2 ZEROS
;
	SUB	A		;
	CALL	PTWDG		;
	SUB	A		;
	CALL	PTWDG		;
;
; OUTPUT RECORD TYPE 04 AND THEN DATA
;
	LD	A,4		;
	LD	HL,RBUF		; HL -> BUFFER
	LD	(RPOINT),HL	; REINIT BUFFER POINTER
DOCTOR:	INC	B		; INCR COUNTER
	NOP			;
BLOOP:	CALL	PTWDG		; CONVERT AND OUTPUT
	LD	A,(HL)		; GET NEXT DATA BYTE
	INC	HL		;
	DJNZ	BLOOP		; LOOP FOR ALL
EOTDOC:	SUB	A		; PREPARE CHECKSUM
	SUB	C		;
	CALL	PACC		;
	CALL	CRLF		; OUTPUT CR AND LF
	SUB	A		; READY TO ZERO A COUNTER
	RET			;
;
; BUFFER UP RELOCATABLE ADDRESSES
;
; SET FLAG TO INDICATE THAN AN EXTERNAL
; REFERENCE IS ALLOWED FOR THIS OPCODE.
;
ROUT:	SET	EXTOK,(IX+SFLAG);
;
; IF ABSOLUTE ASSEBLY,NO RELOCATION INFO
;
	BIT	ABSFLG,(IX+LDFLAG);
	RET	NZ		;
;
; IF NOT RELOCATING INSTRUCTION, RETURN TO CALLER
;
	BIT	RELFLG,(IX+SFLAG);
	RET	Z		;
;
; ELSE SET LISTING RELOCATE FLAG
;
	SET	LRLFLG,(IX+SFLAG)
;
; IF NO OBJECT OUTPUT, RETURN TO CALLER
;
	BIT	OBJFLG,(IX+OPFLAG);
	RET	Z		;
;
; IF PASS 1, DO NOT OUTPUT OBJECT CODE
;
	BIT	PASS2,(IX+OPFLAG); OPERATIONS FLAG
	RET	Z		; IF PASS 1 RETURN;
;
; BUILD RELOCATION BUFFER
;
	PUSH	AF		; SAVE REGISTERS
	EXX			; SWITCH TO PRIMED REGS
	LD	A,(IX+RCOUNT)	; ACCESS COUNT OF CHARACTER
	BIT	5,A		; UP TO 32 YET?
	CALL	NZ,RELOUT	; IF SO, OUTPUT BUFFER
	ADD	A,2		; INCR COUNT BY 2
	LD	(IX+RCOUNT),A	; SAVE UPDATE COUNT
	LD	HL,(REFL)	; ACCESS PROGRAM COUNTER
	LD	C,(IX+OPLEN)	; GET OPCODE LENGTH
	DEC	C		; DECR TWICE
	DEC	C		;
	LD	B,0		;
;
; GET ADDRESS OF DATA TO BE RELOCATED
;
	ADD	HL,BC		;
	EX	DE,HL		;
	LD	HL,(RPOINT)	; HL-> RELOCATION BUFFER
	LD	A,D		; SAVE MSBBYTE
	LD	(HL),A		;
	INC	HL		; GET TO NEXT BYTE
	LD	A,E		;
	LD	(HL),A		; LSBYTE
	INC	HL		;
	LD	(RPOINT),HL	; SAVE UPDATED POINTER
	EXX			; RESTORE REGS
	POP	AF		;
	RET			;
;
;*SYMBOL TABLE MANIPULATOR FOR ASMB-80
;
; ENTRY: HL -> SYMBOL
; A=CALL CODE
; BIT 0: 0 -LOCATE SYMBOL AND RETURN VALUE IN
;	 1 - ENTER SYMBOL INTO TABLE
; BIT 2: 0 -NORMAL CALL
;	 1- GLOBAL CALL FOR GLOBAL PSEUDO-OP
;
; EXIT: ZERO - NO ERROR, NON ZERO - ERROR
;	ERROR CODE IS SET BY ERRORS.
;	HL -> CHARACTER AFTER SYMBOL
;	DE = RETURNED VALUE
;	IY	-> SYMBOL IN SYMBOL TABLE
;
; REGISTER USAGE:
; X- CHANGED
; M- INPUT, MAINTAINED
; I- INPUT, CHANGED
; R-  RESULT
;
; A-M (CALL CODE)
; C-X
; DE-R
; HL-I
; A' THRU L' -X
; IY -> SYMBOL TABLE ENTRY
;
; INITIALIZATION
;
;
; BLANK HOLDING BUFFER
;
SYMBOL:	LD	DE,SYMBUF	; DE -> TEMPORARY BUFFER
;
; ACCESS SYMBOL AND PUT INTO TEMPORARY BUFFER
;
	CALL	SYMCHK		; ALSO CHECK SYMBOL
	RET	NZ		; RETURN IF ERRORS
	EX	AF,AF'		; SAVE CALL CODE
;
; SAVE ORIGINAL SOURCE POINTER
;
	PUSH	HL		;
	LD	HL,SYMBUF	; HL ->SYMBOL BUFFER
	PUSH	HL		; SAVE PTR
	LD	IY,(SYMTAB)	; INIT SYMBOL TBL PTR
	PUSH	IY		; SAVE PTR
	LD	DE,9		; SET UP INCREMENTER
	JR	SYMSTR		;SKIP TO START
;
CLOOP:	POP	IY		; IY -> SYMBOL TABLE
	ADD	IY,DE		; GET TO NEXT ENTRY IN TABLE
	POP	HL		; HL -> SOURCE
	PUSH	HL		; SAVE PTR
	PUSH	IY		; SAVE PTR
;
; THIS IS PRETTY NIFTY, HUH?
;
SYMSTR:	LD	B,6		; GET SYMBOL LENGTH
CLOOP1:	LD	A,(HL)		; GET SOURCE CHARACTER
	CP	(IY+0)		; CHECK AGAINST SYMTAB
	JP	C,AA		; IF SOURCE CHAR <
;
; SYMTAB CHAR, THEN NOT FOUND.
; (TABLE IS IN ALPHA ORDER).
;
	JR	NZ,CLOOP	; IF NO MATCH, LOOP FOR N
;
; SOURCE CHAR MATCHES SYMTAB CHARACTER, CHECK MOR
;
	INC	HL		; INCR SOURCE PTR
	INC	IY		; INCR SYMTAB PTR
	DJNZ	CLOOP1		; LOOP FOR LENGTH OF SYMB
;
; SYMBOL FOUND IN TABLE
;
BB:	POP	IY		; IY -> SYMTAB ENTRY
	POP	HL		; HL -> SOURCE
	LD	B,(IY+6)	; PRESET FOR CHECK
	LD	C,(IX+OPFLAG)	;
	EX	AF,AF'		; GET CALL CODE
	BIT	GLBFLG,A	; GLOBAL CALL?
	JR	Z,BBA		; NO, SKIP
;
; GLOBAL CALL, PASS 1 OR 2?
;
	BIT	PASS2,C		;
	JR	Z,GLBCAL	; PASS 1, SKIP
;
; GLOBAL CALL, SYMBOL FOUND IN TABLE, PASS 2
;
	BIT	GLBFLG,B	; ITS SYMBOL MARKED GLOBAL
	JR	NZ,BRETPT	; YES, RETURN
	JP	UNDEFD		; ELSE UNDEFINED
;
; PASS1...MARK SYMBOL GLOBAL AND RELOCATABLE
;
GLBCAL:	SET	GLBFLG,(IY+6)	;
	SET	RELFLG,(IY+6)	;
	JR	BRETPT		; GO RETURN TO CALLER
;
; EQUATE MODE?
;
BBA:	BIT	EQUMOD,(IX+SFLAG);
	JR	Z,BBB		; NO SKIP
;
; EQUATE MODE, PASS 1 OR 2?
;
	BIT	PASS2,C		;
	JR	NZ,BB2		; PASS 2, SKIP
;
; PASS 1...IS SYMBOL DEFINED IN PASS 1?
;
	BIT	DEFIN1,B	; DEFINED?
	JR	NZ,RESULT	; YES, RETURN RESULT
;
; NO IN PASS 1 FALLS THRU THE NEXT CHECK
;
BB2:	BIT	DEFIN2,B	; DEFINED IN PASS 2?
	JR	NZ,RESULT	; YES, RETURN RESULT
	JR	UNDEFD		; ELSE UNDEFINED
;
; ENTER SYMBOL CALL?
;
BBB:	BIT	0,A		;
	JR	Z,CC		; NO, SKIP
;
; ENTER SYMBOL CALL, PASS 1 OR 2?
;
	BIT	PASS2,C		;
	JR	NZ,BBB2		; PASS 2,SKIP
;
; PASS 1, DEFINED IN PASS 1?
;
	BIT	DEFIN1,B	;
	JP	Z,SETVAL	; NO,SKIP
	JR	MULTD		; ELSE MULTIBLE DEFINITION
;
; PASS 2, DEFINED IN PASS 2?
;
BBB2:	BIT	DEFIN2,B	;
	JP	Z,SETVAL	; NO, SKIP
MULTD:	LD	(IX+ERRCOD),MLTDEF; MULTIPLE DEFINITION
	JP	SETVAL		;G O SET UP VALUE
;
; NOT ENTER SYMBOL CALL )LOCATE CALL).
; DEFINED IN PASS 1 OR 2?
;
CC:	BIT	DEFIN1,B	;
	JR	NZ,RESULT	; YES, RETURN RESULT
	BIT	DEFIN2,B	;
	JR	Z,CC1		; NO, SKIP
;
; DEFINED, RETURN RESULT TO CALLER
;
RESULT:	LD	D,(IY+7)	;
	LD	E,(IY+8)	;
BRETPT:	SUB	A		; ZERO
;
; RESTORE ORIGINAL SOURCE POINTER
;
	POP	HL		;
	RET			;
;
; PASS 1 OR 2?
;
CC1:	BIT	PASS2,C		;
	JR	Z,BLDEXT	; PASS 1, SKIP
	BIT	GLBFLG,B	; GLOBAL SYMBOL
	JR	Z,UNDEFD	; NO, UNDEFINED
;
; GLOBAL SYMBOL MUST BE DEFINED IN PASS 1
;
; BUILD EXTERNAL LINK LIST FOR GLOBAL EXT REF'S
;
; INITIALIZE VALUE RETURNED
;
BLDEXT:	LD	D,(IY+7)	;
	LD	E,(IY+8)	;
	SET	RELFLG,(IY+6)	; SET RELOC FLAG
;
;*********MAY HAVE TO RESET THIS IN STOUT
; FIRST TIME THIS SYMBOL USED?
;
	BIT	FSTEXT,B	;
	JR	NZ,NOFST	; NO, SKIP
;
; 1ST TIME SYMBOL HAS BEEN ACCESSED.
; RETURN TERMINATOR 0FFFFH.
;
	LD	DE,0FFFFH
;
; RESET RELOCATION FLAG UNCONDITIONALLY
;
	RES	RELFLG,(IY+6)
;
NOFST:	SET	FSTEXT,(IY+6)	; SET 1ST TIME FLAG
	LD	C,(IX+OPLEN)	; GET OPCODE LENGTH
	DEC	C		; DECR BY 2
	DEC	C		;
	LD	B,0		;
	LD	HL,(REFL)	; ACCESS PROGRAM COUNTER
	ADD	HL,BC		; HL -> ADDRESS OF NEXT ENTRY
	LD	(IY+7),H	; SAVE POINTER ADDRESS
	LD	(IY+8),L	;
	JR	BRETPT		; SKIP
;
; ERROR EXITS
;
TABLFL:	LD	A,TABFUL	; SYMBOL TABLE FULL
	JP	ABORT		; ABORT THE ASSEMBLY
;
UNDEFD:	LD	(IX+ERRCOD),UNDEFR; UNDEFINED SYMBOL
;
ERRET:	SUB	A		;
	INC	A		; SET NON ZERO
;
; RESTORE ORIGINAL SOURCE POINTER
;
	POP	HL		;
	RET			;
;
; SYMBOL NOT FOUND
; ENTER IT INTO THE TABLE
;
AA:	EXX			; PRIMED REGS FOR THIS MAP
	POP	DE		; DE -> SYMBOL TABLE ENTRY
	POP	HL		; HL -> SOURCE
;
; EQUATE MODE?
; IF SO, SYMBOL IS UNDEFINED.
;
	BIT	EQUMOD,(IX+SFLAG);
	JR	NZ,UNDEFD	; YES, UNDEFINED
;
; PASS 1 OR 2?
;
	EX	AF,AF'		; GET CALL CODE
	BIT	PASS2,(IX+OPFLAG);
	JR	Z,AA1		; PASS 1,SKIP
;
; PASS 2, CHECK FOR GLOBAL CALL OR LOCATE CALL
;
	BIT	GLBFLG,A	; GLOBAL CALL?
;
; GLOBAL SYMBOL MUST BE DEFINED IN PASS 1.
;
	JR	NZ,UNDEFD	;
;
; ENTER SYMBOL CALL?
;
	BIT	0,A		;
;
; IF SYMBOL DOES NOT EXIST IN TABLE
; AND NOT ENTER SYMBOL MODE (LOCATE
; SYMBOL) IN PASS 2, THEN UNDEFINED ERROR.
;
	JR	Z,UNDEFD	;
;
; ENTER SYMBOL INTO TABLE
;
AA1:	EX	AF,AF'		;SAVE CALL CODE
	PUSH	HL		;SAVE SOURCE PTR
	PUSH	DE		;SAVE SYMTAB PTR
;
; ENTER SYMBOL INTO TABLE
;
; MOVE TABLE UP FROM PRESENT LOCATION BY 9 BYTES
;
	LD	HL,(SYMPTR)	; HL -> EOD IN TABLE
	LD	BC,9		; BC=9
	ADD	HL,BC		; HL -> EOD + 9 (NEW EOD)
	LD	(SYMPTR),HL	; UPDATE POINTER
	PUSH	HL		; SAVE IT
	ADD	HL,BC		; HL -> EOD +9+9
	PUSH	HL		; SAVE IT
	LD	HL,(SYMPTR)	; HL -> NEW EOD
	PUSH	HL		; SAVE IT TEMPORARILY
	AND	A		; RESET CARRY
	SBC	HL,DE		; HL -> NEW EOD - PTR
	INC	HL		; INCR COUNT BY 1
;
; DE IS THE POINTER INTO THE SYMBOL TABLE
;
	PUSH	HL		; SAVE BYTES TO MOVE
	POP	BC		; BC = BYTES TO MOVE
;
; CHECK FOR SYMBOL TABLE FULL
;
	LD	HL,(SYMEND)	; HL -> END OF TABLE
	POP	DE		; DE -> EOD + 9
	SBC	HL,DE		; CHECK FOR END
	JR	C,TABLFL	; IF CARRY, TABLE FULL E
	POP	DE		; DE -> EOD +9 +9
	POP	HL		; HL -> EOD +9
;
; (DE) <- (HL) FOR BC
;
	LDDR			; MOVE THEM ALL
;
; NOW PUT SYMBOL INTO THE TABLE
;
PUTSYM:	EXX			; UNPRIMED REGISTERS
	POP	DE		; DE -> SYMTAB INDEX
	PUSH	DE		;
	POP	IY		; PUT INTO IY
	POP	HL		; HL -> SOURCE
	LD	BC,6		; BC = LENGTH OF SYMBOL
	LDIR			; (DE) <- (HL) FOR BC
	LD	(IY+6),B	;
	LD	(IY+7),B	;
	LD	(IY+8),B	; ZERO FLAGS AND VALUE
;
; CHECK CALL CODE FOR FINISH UP
;
; IF GLOBAL CALL, MARK SYMBOL GLOBAL AND
; RELOCATABLE AND EXIT
;
	EX	AF,AF'		; GET CALL CODE
	BIT	GLBFLG,A	;
	JP	NZ,GLBCAL	; GLOBAL CALL, SKIP OUT
;
; IF NOT ENTER SYMBOL CALL (LOCATE CALL),
; THEN BUILD EXT LINK LIST
;
	BIT	0,A		;
	JP	Z,BLDEXT	;
;
; SET VALUE OF SYMBOL AND DEFINED BIT
;
; CHECK FOR PASS 1 OR 2 TO SET
; APPROPRIATE DEFINED BIT.
;
SETVAL:	SET	DEFIN1,(IY+6)	; ALWAYS SET DEFINED
	BIT	PASS2,(IX+OPFLAG);
	JR	Z,SET1		; IF PASS 1, SKIP
	SET	DEFIN2,(IY+6)	; ELSE SET DEFINED 2
SET1:	LD	HL,(REFL)	; GET PROGRAM COUNTER
	LD	(IY+7),H	; SET VALUE OF SYMBOL
	LD	(IY+8),L	;
;
; RESTORE ORIGINAL SOURCE POINTER (UPDATED)
;
	POP	HL		;
;
; IF RELOCATABLE FLAG SET, SET REL BIT FOR SYMBOL
;
	BIT	RELFLG,(IX+SFLAG);
	RET	Z		; RETURN TO ZERO
	SET	RELFLG,(IY+6)	; SET SYMBOL RELOCATE
	SUB	A		; SET ZERO
	RET			;
;
; SYSTEM ROUTINES FOR ASMB-80
;
NXTFLD:	INC	HL		; INCR SOURCE PTR
	CALL	CHKDEL		; MOVE TO NEXT NON BLANK
	JR	NZ,NXTFLD	; DELIMITER NOT FOUND
;
; DELIMITER FOUND, NOW ADVANCE TO NON BLANK CHAR
;
	CALL	SEMICR		; CHECK FOR CR OR ;
	RET	Z		; IF SO, RETURN ZERO
NXTCHR:	INC	HL		; GET TO NEXT CHAR
	CALL	CHKDEL		; DELIMITER?
	RET	NZ		; NOPE, RETURN TO CALLER
	CALL	SEMICR		; SEMICOLON OR CR?
	JR	NZ,NXTCHR	; NO, LOOP FOR MORE
	RET			; ELSE RETURN TO CALLER
;
CHKDEL:	LD	A,(HL)		; CHECK FOR DELIMITER
	CP	' '		; RETURN FOR BLANK
	RET	Z		;
	CP	HT		; RETURN FOR TAB
	RET	Z		;
	CP	','		; RETURN FOR COMMA
	RET	Z		;
	CP	':'		; RETURN FOR COLON
	RET	Z		;
;
; ELSE LOOK FOR CR OR
;
SEMICR:	LD	A,(HL)		;
	CP	CR		; CR?
	RET	Z		;
	CP	$3B		; SEMICOLON?
	RET			; RETURN ZERO OR NOT ZERO
;
; CHARACTER STRING PROCESSING FOR QUOTES
;
; THIS ROUTINES RETURN A CHARACTER FROM AN
; ASCII STRING EACH TIME IT IS CALLED.
; QUOTES ARE HANDLED PROPERLY.
;
; ENTRY: DE -> SOURCE BUFFER (1ST CHAR
;		AFTER QUOTE CHAR).
;	 C = 0FFH (QUOTE FLAG)
;
; EXIT:	ZERO, DONE
;	NON ZERO, CONTINUE LOOKING FOR CLOSING QUOTE
;	A - RETURNED CHARACTER
;	ERRCOD IS SET TO SYNTAX ERROR IF UNBALANCED
;	QUOTES.
;
QPROC:	INC	DE		; INCR SOURCE POINTER
QPROC2:	LD	A,C		; CHECK QUOTE FLAG
	AND	A		; CHECK IT
	RET	Z		; RETURN ZERO IF DONE WITH
	LD	A,(DE)		; GET SOURCE CHARACTER
	AND	7FH		; MASK OF BIT IN QUOTE S
	CP	CR		; CR?
	JR	Z,QERROR	; YES, ERROR SKIP
	CP	27H		; QUOTE CHAR?
	RET	NZ		; NO, RETURN NON ZERO, NO
	INC	DE		; GET NEXT CHARACTER
	LD	A,(DE)		; ACCESS IT
	AND	7FH		; MASK OF BIT IN QUOTE S
	CP	27H		; QUOTE?
	JR	Z,QQUOTE	; IF SO, RETURN QUOTE CHAR
;
; NOT QUOTE, FLIP QUOTE FLAG
;
	LD	A,C		;
	CPL			;
	LD	C,A		;
	JR	QPROC2		; AND GO RETURN;
QERROR:	LD	(IX+ERRCOD),UNQUOT; SYNTAX ERROR
	SUB	A		; RETURN ZERO (DONE)
QQUOTE:	AND	A		; GET NON ZERO FLAG
	RET			;
;
	.BYTE	0FFH		; in ROM included
;
; ABORT ASSEMBLY AND RETURN TO MONITOR
;
ABORT:	LD	HL,ABTMSG	; HL -> ABORT MASQAGE
	PUSH	AF		; SAVE CODE
	LD	E,0		; CONSOLE CHANNEL
	CALL	PTXT		;
	POP	AF		; GET CODE
	LD	D,A		; INTO D
	CALL	WRCHR		; AND WRITE IT OUT
	JP	MONITR		; RETURN TO MONITOR
;
ABTMSG:	.BYTE	"ABORT ERROR="	;
	.BYTE	03H		;
;
; DOUBLE BYTE BCD INCREMENT.
; ENTER WITH PACKED BCD VALUE IN HL-REGISTER.
; HL IS INCREMENTED BY 1 AND ADJUSTED TO
; PACKED BCD
;
BCDINC:	AND	A		; RESET CARRY
	LD	A,L		; GET LS BYTE
	INC	A		; INCREMENT IT
	DAA			; DECIMAL ADJUST
	LD	L,A		; SAVE BACK
	LD	A,0		; ZERO A-REG
	ADC	A,H		; ADD WITH CARRY MS BYTE
	DAA			; DECIMAL ADJUST
	LD	H,A		; SAVE BACK
	RET			;
;
; SYMBOL CHECK ROUTINE
;
; ENTRY: HL -> SOURCE
;	 DE -> BUFFER TO BE PUT INTO
;
;	 A = CALL CODE...0 = ENTER SYMBOL
; (SYMBOL IS TERMINATED BY DELIMIETR).
;  ...1= LOCATE SYMBOL (SYMBOL IS
; TERMINATED BY DELIMITER OR OPERATOR
;
; EXIT:  HL -> NEXT CHAR AFTER SYMBOL
;	 DE -> NEW BUFFER END
;	 C= LENGTH OF SYMBOL (MAX 6).
;
SYMCHK:	PUSH	AF		; SAVE CALL CODE
	LD	C,0		; INIT COUNTER
	LD	B,6		; SET MAX COUNT
	LD	A,(HL)		; GET FIRST CHARACTER
	CP	21H		; CHAR < 21H ?
	JR	C,LABERR	; IF SO, ERROR
	CP	3FH		; 26H < CHAR < 3FH ?
	JR	NC,OK1		;
	CP	26H+1		;
	JR	NC,LABERR	;
OK1:	LD	(DE),A		; SAVE CHARACTER
	INC	DE		;
	INC	HL		;
	INC	C		; INCR COUNTER
	CALL	CHKDEL		; DELIMITER?
	JR	Z,DSYMP		; YES, DONE
	CALL	CHKOPR		; OPERATOR?
	JR	NZ,OK3		; NO OK, SKIP
	POP	AF		; GET CALL CODE
	PUSH	AF		; SAVE AGAIN
	BIT	0,A		; ENTER SYMBOL CALL?
	JR	Z,DSYMP		; LOCATE SYMBOL CALL, DONE
;
; ELSE LABEL ERROR
;
LABERR:	LD	(IX+ERRCOD),LBLERR; LABEL ERROR
	POP	AF		; BALANCE STACK
	INC	A		; RETURN NON ZERO
	RET			;
;
OK3:	DJNZ	OK1		; LOOP FOR UP TO 6
	JR	DSYM		; SKIP
;
;*****GIVE YOURSELFF SOME ROOM BETWEEN BUFFERS
;
DSYMP:	LD	A,' '		; FILL THE BUFFER WITH BLANKS
DSYML:	LD	(DE),A		;
	INC	DE		;
	DJNZ	DSYML		; LOOP FOR REST OF BUFFER
DSYM:	POP	AF		; RESTORE CALLCODE
	CP	A		; RETURN ZERO
	RET			;
;
; EXPRESSION EVALUATOR
; ENTRY: DE -> SOURCE
;
; EXIT: UPON NOT FOUND CONDITION.
; DE UPDATED
; HL = RESULT
; ZERO - NO ERRORS, NON ZERO - ERRORS.
; ALL OTHER REGISTERS ARE CHANGED.
;
EXPR:	LD	HL,0		; ZERO RESULT
	LD	(IX+RFLG),H	; ZERO REL FLAGS
	CALL	EXPR1		; EVALUATE EXPR
;
; CHECKE RELOCATION FLAG RESULT. FORMULA IS:
; <REL> OP <REL> = <ABS>
; <REL> OP <ABS> = <REL>
; <ABS> OP <REL> = <REL>
; <ABS> OP <ABS> = <ABS>
;
	BIT	RESFLG,(IX+SFLAG); RESULT OBERFLOW?
	JR	Z,NRESET	; NO, SKIP
	LD	A,(IX+ERRCOD)	; CHECK ERROR CODE
	SUB	OVFERR		; FOR OVERFLOW
	JR	NZ,NRESET	; NO, SKIP
	LD	(IX+ERRCOD),A	; ELSE RESET ERROR CODE
NRESET:	RES	RELFLG,(IX+SFLAG); RESET RELFLG
	BIT	7,(IX+RFLG)	; CHECK R2 OF RFLG
	JR	Z,NOSREL	;
;
; ELSE SET RELOCATION FLAG
;
	SET	RELFLG,(IX+SFLAG)	;
NOSREL:	LD	A,(IX+ERRCOD)	; CHECK FOR ERRORS
	AND	A		;
	JR	Z,CRETPT	; NO,SKIP
	LD	HL,0		;
CRETPT:	RET			;
;
; CHECK FOR LOGICAL OPERATOR
;
EXPR1:	LD	A,(DE)		; GET CHARACTER
	CP	'-'		; UNARY MINUS?
	JR	NZ,XP3A	;NO, SKIP
	LD	HL,0		; READY FOR 2'S COMPLEMENT
	JR	XP26		; AND GO SUBTRACT
;
XP3A:	CP	'+'		; UNARY PLUS?
	JR	NZ,XP4		; NO, SKIP
	INC	DE		; IGNORE PLUS
XP4:	CALL	EXPR2		; GET 1ST <EXPR2>
XP6:
XP22:	LD	A,(DE)		; GET CHARACTER
	CP	'+'		; ADDITION?
	JR	Z,XP26		; YES, SKIP
XP25:	CP	'-'		; SUBTRACT?
	JR	NZ,XP30		; NO, SKIP
XP26:	INC	DE		; INCR TEXT POINTER
	PUSH	HL		; SAVE 1ST
	PUSH	AF		; SAVE A-REG
	CALL	EXTCHK		; CHECK EXT REF'S
	CALL	EXPR3		; GET SECOND <EXPR3>
	CALL	RELCHK		; CHECK FLAGS
	POP	AF		; RESTORE A-REG
	EX	DE,HL		; DE = 2ND
	EX	(SP),HL		; TOS=TEXT PTR
	CP	'-'		; CHECK FOR SUBTRACT
	JR	Z,XP27		; YES, SKIP
	AND	A		; RESET CARRY
	ADC	HL,DE		; ADD
	JR	XP28		; SKIP
XP27:	SBC	HL,DE		; SUBTRACT
XP28:	CALL	PE,OVFLOW	; IF OVERFLOW, MARK IT
	POP	DE		; RESTORE TEXT PTR
	JR	XP6		;
;
XP30:	CP	'.'		; DOT OPERATOR?
	JR	NZ,XP33		; NO, SKIP
;
; DOT... SHIFT RESULT RIGHT BY 8 BITS
;
	INC	DE		;
	LD	L,H		;
	LD	H,0		;
	CALL	EXTCHK		; CHECK EXT REF'S
	JR	XP6		; AND LOOP FOR MORE
;
XP33:	EX	DE,HL		; HL -> SOURCE
	CALL	CHKDEL		; CHECK FOR DELIMITER
	EX	DE,HL		;
	RET	Z		;
	CP	')'		; CHECK FOR CLOSING PARENTS
	RET	Z		;
;
; CHECK FOR TRAILING OPERATOR
;
	CALL CHKOPR		;
;
; IF NOT, THEN OK. THIS HANDLES A BIG LABEL PROP
;
	RET	NZ		;
;
; ELSE ILLEGAL OPERATOR ERROR
;
	LD	(IX+ERRCOD),BADOPR;
	RET			;
;
EXPR2:	
EXPR3:
EXPR4:				; OBTAIN <EXPR4>
	LD	A,(DE)		; GET CHARACTER
	CP	')'		; CHECK FOR RIGHT PARENTS
	RET	Z		; DONE RETURN 	
	CP	'('		; CHECK FOR START OF AN E
	JR	NZ,CHKNUM	; NO, SKIP
	INC	DE		; INCREMENT SOURCE PTR
	CALL	EXPR1		; AND EVALUATE EXPRESSION
	INC	DE		; GET PAST CLOSING PARENTS
	RET			;
;
CHKNUM:	RES	7,(IX+RFLG)	; RESET R2 OF REL FLAG
	CP	'0'		; CHECK FOR NUMBER
	JP	C,NOTNUM	; NO, SKIP
	CP	'9'+1		; A-'9'-1
	JP	NC,NOTNUM	; NO,SKIP
;
; NUMBER FOUND, DECODE IT AND RETURN VALUE IN HL
;
; PRESET REGISTERS FOR CONVENTION
;
	LD	C,'7'+1		; OCTAL HIGHEST DIGIT +1
	EXX			;
	LD	C,0		; C' = NOT DECIMAL FLAG
	LD	B,3		; B' = BASE OF OCTAL
	LD	HL,0		; HL'=RESULT=0
	EXX			;
	PUSH	DE		; SAVE SOURCE PTR
	LD	B,-2		; INIT CHARACTER COUNETR
BASEL:	LD	A,(DE)		; GET CHARACTER FROM SOURCE
	INC	B		; INCR CARACTER COUNETR
	INC	DE		;
	CALL	AORN		; CHECK FOR ALPHANUMERIC
	AND	A		;
	JR	Z,BASEL		; ALPHANUMERIC FOUND, LOOP
;
; NOT ALPHANUMERIC, MUST BE A TERMINATOR
;
	DEC	DE		; BACK UP TO TERMINATOR
	PUSH	DE		;
	POP	IY		; SAVE SOURCE IN IY=REG
	DEC	DE		; BACK UP ONE TO GET BASE
	LD	A,(DE)		; GET BASE CHARACTER
;
; CHECK BASE CHARACTER
;
	CP	'H'		; HEX?
	JR	Z,HEX		; YES, SKIP
	CP	'D'		; DECIMAL?
	JR	Z,DEC		;
	CP	'O'		; OCTAL
	JR	Z,OCT		;
	CP	'Q'		; OCTAL?
	JR	Z,OCT		;
	CP	'B'		; BINARY?
	JR	Z,BIN		;
;
; ELSE ASSUME DECIMAL
;
	INC	B		; INCR CARACTER COUNTER
;
; TO INCLUDE LAST BYTE OF THE NUMBER
;
DEC:	LD	C,'9'+1		; 1 ABOVE HIGHEST DIGIT
	EXX			;
	LD	C,1		; C'=DECIMAL CONVERSATION FLAG
	LD	B,2		; B'=2 FOR DECIMAL CONVERT
	JR	CONV		;
;
BIN:	LD	C,'2'		; 1 ABOVE HIGHEST DIGIT
	EXX			;
	LD	B,1		; B' =BASE
	JR	CONV		; GO CONVERT
;
HEX:	LD	C,'F'+1		; ONE ABOVE HIGHEST DIGIT
	EXX			;
	INC	B		; B' = BASE =4
CONV:	EXX			; GET BACK TO RGULAR REG
OCT:	POP	DE		; IY -> SOURCE
HLOOP:	EXX			; GET PRIMED REGS
	LD	DE,0		; DE'=TEMP RESULT FOR DE
	LD	A,C		; BASE=DECIMAL?
	AND	A		;
	JR	Z,NOTDEC	; NOT DECIMAL, SKIP
;
; DECIMAL START OF CONVERSION
;
	ADC	HL,HL		; DO 1ST PART OF CONVERSION
	CALL	C,OVFLOW	; OVERFLOW INDICATION
	PUSH	HL		; SAVE INCREMENT RESULT
	POP	DE		; IN DE'
NOTDEC:	PUSH	BC		; SAVE BASE
HLOOP1:	AND	A		; RESET CARRY
	ADC	HL,HL		; CONTINUE CONVERSION
	CALL	C,OVFLOW	; OVERFLOW INDICATION
	DJNZ	HLOOP1		; LOOP FOR BASE COUNT TO
	POP	BC		; RESTORE BASE
	AND	A		; RESET CARRY
	ADC	HL,DE		; ADD IN DECIMAL INTERMED
	CALL	C,OVFLOW	; OVERFLOW INDICATION
	EXX			; NORMAL REGS
	LD	A,(DE)		; IY -> SOURCE, GET NEXT DI
	INC	DE		; INCR SOURCE PTR
	CP	'0'		; CHECK FOR LOWEST NUMBER
	JR	C,BADDIG	; ILLEGAL DIGIT
	CP	C		; CHECK HIGHEST NUMBER
	JR	NC,BADDIG	; ILLEGAL DIGIT
	CP	'A'		; CHECK RANGE
	JR	C,SMALDG	; OK
	SUB	7		; CONVERT HEX NUMBER
SMALDG:	AND	0FH		; MASK
;
; ADD IN CONVERTED DIGIT TO RESULT
;
	EXX			;
	AND	A		; RESET CARRY
	ADD	A,L		; HL'=RESULT
	LD	L,A		;
	LD	A,0		; RESET A REG
	ADC	A,H		; ADD CARRY TO UPPER BYTE
	CALL	C,OVFLOW	; IF CARRY, THEN OVERFLOW
	LD	H,A		; AND SAVE IT
	EXX			;
	DJNZ	HLOOP		; B =NBR OF CHARS TO CONVERT
;
; PUT RESULT INTO HL REG
;
	EXX			; PRIMED REGS
	PUSH	HL		; PUSH HL'
	EXX			; GET NORMAL
	POP	HL		; POP INTO HL
	PUSH	IY		; RESTORE SOURCE PTR
	POP	DE		;
	RET			;
;
BADDIG:	LD	(IX+ERRCOD),DIGERR; ILLEGAL DIGIT
	RET			; RETURN TO CALLER
;
; NOT A NUMBER OR ( OR), CHECK FOR$
;
NOTNUM:	CP	'$'		; PROGRAM COUNTER?
	JR	NZ,CHKASC	; NO, GO CHECK FOR ASCII
;
; PC FOUND, RETURN CURRENT VALUE
;
; LOOKS LIKE PC, BUT CHECK FOR SYMBOL
;
	PUSH	DE		;
	POP	HL		; HL ->SOURCE
	INC	HL		; GET NEXT CHARACTER
	CALL	CHKDEL		; IS NEXT CHARACTER A DELIMITER
	JR	Z,PCFND		; IF SO, THEN PC FOUND
	CALL	CHKOPR		; OR IS IT AN OPERATOR?
	JR	NZ,SYM		;IF NOT, MUST BE SYMBOL
PCFND:	INC	DE		; INCR TEXTPTR
	LD	HL,(REFL)	;
;
; SET RESET OVERFLOW FLAG TO PREVENT OVERFLOW
; WHILE USING THE PROGRAM COUNTER
;
	SET	RESFLG,(IX+SFLAG);
;
; SET FLAG
;
	SET	7,(IX+RFLG)	; SET R2 OF RFLG
	RET			;
;
CHKASC:	CP	27H		; CHECK FOR ASCII CONSTANT
	JR	NZ,SYM		; NO, CHECK FOR SYMBOL
;
; ASCII CHARACTERS, DECODE
;
	LD	C,0FFH		; SET QUOTE FLAG
	LD	HL,0		; INIT RESULT
;
; CHARACTERS ARE SHIFTED INT HL UNT L A
; CLOSING QUOTE IS ENCOUNTERED. THUS, HL
; WILL CONTAIN THE LAST TWO CHARS IN THE
; QUOTE STRING
;
ASLOOP:	CALL	QPROC		; PROCESS QUOTE STRING
	RET	Z		; RETURN IF DONE
;
; ELSE SHIFT CHAR INTO HL
;
	LD	H,L		;
	LD	L,A		;
	JR	ASLOOP		; AND LOOP FOR MORE
;
; MUST BE A SYMBOL, FIND ITS VALUE
;
SYM:	EX	DE,HL		; HL -> SYMBOL START
	SUB	A		; A=0, IOCATE SYMBOL AND
	CALL	SYMBOL		;
;
; IF EXTERNEL SYMBOL, SET EXTFLG.
;
	EX	DE,HL		; DE	->SOURCE, HL= VALUE
	LD	A,(IY+6)	; GET SYMBOL FLAG
; CHECK FOR DEFIN2 OR DEFIN1
	AND	7		;
	SUB	4		;
	JR	NZ,CHKREL	; NOT EXTERNAL, SKIP
;
; EXTERNAL SYMBOL FOUND, SET FLAGS
;
	SET	EXTFLG,(IX+SFLAG); EXTERNAL REFERENCE
CHKREL:	BIT	RELFLG,(IY+6)	; CHECK FOR RELOCATION FLAG
	JR	Z,RETSYM	; IF ZERO, GO RETURN
RELSYM:	SET	7,(IX+RFLG)	; SET R2 OF RFLG
RETSYM:	RET			;
;
OVFLOW:	LD	(IX+ERRCOD),OVFERR; OVERFLOW ERROR
	RET			;
;
; CHECK AND UPDATE RELOCATION FLAGS
; FOR EXPRESSION.
;
RELCHK:	PUSH	AF		; SAVE REG A
	RL	(IX+RFLG)	; ROTATE R2 INTO CY
	RRA			; ROTATE R2 INTO MSB OF A
	XOR	(IX+RFLG)	; XOR R2 AND R1
	LD	(IX+RFLG),A	; AND SAVE AGAIN
	POP	AF		; RESTORE A-REG
;
; CHECK FOR EXTERNAL REFERENCE IN AN EXPRESSION
;
EXTCHK:	SRA	(IX+RFLG)	; SHIFT R2 INTO R1
	BIT	EXTFLG,(IX+SFLAG);
	RET	Z		; IF OK, RETURN
	LD	(IX+ERRCOD),EXTEXP; ELSE ERROR
	RET			;
;
KEYWDS:	.BYTE	00EH,085H,0A1H,0E8H
	.BYTE	09AH,03EH,097H,0AEH,01DH,07DH,0D0H,034H,08DH,047H,052H,07EH,091H,07DH,023H,01AH
	.BYTE	001H,074H,002H,0EFH,041H,016H,086H,04DH,01DH,07AH,066H,09EH,04DH,034H,05AH,06EH
	.BYTE	074H,0FDH,03DH,0DAH,0CEH,08BH,0AFH,07BH
OPCODS:	.BYTE	010H,08BH,0A1H,03DH,07AH,018H,001H,0A1H
	.BYTE	0A3H,044H,046H,089H,07BH,0E8H,0E0H,05CH,0F4H,0D7H,03FH,051H,058H,035H,015H,088H
	.BYTE	01AH,08CH,041H,0A8H,0C4H,040H,0D4H,084H,05DH,02CH,07AH,04CH,074H,020H,02DH,07AH
	.BYTE	013H,0F4H,086H,08BH,043H,020H,0B4H,0F7H,03FH,04FH,0A4H,08FH,0A4H,0BFH,051H,024H
	.BYTE	0F4H,001H,08BH,040H,018H,0F4H,006H,08FH,041H,044H,0F4H,027H,08FH,042H,078H,0E3H
	.BYTE	0A1H,03DH,01AH,013H,0D1H,01DH,00DH,02DH,0CEH,089H,07DH,021H,09AH,043H,074H,086H
	.BYTE	08FH,048H,068H,0E3H,0A4H,035H,01AH,043H,051H,01DH,02CH,063H,0D2H,0C6H,038H,0E9H
	.BYTE	063H,046H,096H,034H,047H,04DH,021H,0B4H,0E8H,0E9H,0D3H,01CH,074H,0E9H,0A2H,03AH
	.BYTE	075H,027H,0A7H,052H,063H,0D3H,0A9H,034H,06AH,024H,096H,0A2H,049H,0A3H,051H,024H
	.BYTE	0DBH,0A8H,0AFH,051H,058H,0B5H,015H,08FH,051H,08EH,0A3H,011H,06AH,031H,01EH,0A3H
	.BYTE	029H,0EAH,041H,016H,0A4H,049H,0EAH,04BH,006H,0A5H,010H,06AH,051H,05EH,0A5H,040H
	.BYTE	0EAH,0EEH,08EH,086H,042H,087H,043H,021H,059H,0A1H,090H,0B6H,0D0H,0C8H,059H,068H
	.BYTE	08DH,01AH,00BH,0A3H,02DH,0C1H,002H,0F4H,082H,0E9H,0D1H,036H,088H,0D1H,0E8H,089H
	.BYTE	020H,0A7H,0A9H,0A2H,06BH,026H,096H,089H,04FH,04DH,05AH,025H,03DH,034H,00CH,026H
	.BYTE	09FH,022H,00AH,07AH,060H,005H,01DH,011H,0A3H,066H,089H,00AH,068H,064H,02AH,0F5H
	.BYTE	0EFH,07BH,0DEH
;
; POINTER TABLE TO OPTABL
;
TSP:	.BYTE	0		; LD
	.BYTE	34		; JR
	.BYTE	39		; CALL
	.BYTE	48		; CP
	.BYTE	51		; INC
	.BYTE	58		; DEC
	.BYTE	65		; POP
	.BYTE	70		; PUSH
	.BYTE	75		; JP
	.BYTE	87		; RET
	.BYTE	96		; AD
	.BYTE	103		; ADD
	.BYTE	115		; AND
	.BYTE	118		; BIT
	.BYTE	120		; CPD
	.BYTE	121		; CPDR
	.BYTE	122		; CPI
	.BYTE	123		; CPIR
	.BYTE	124		; DJNZ
	.BYTE	125		; EX
	.BYTE	129		; IM
	.BYTE	130		; IN
	.BYTE	133		; IND
	.BYTE	134		; INDR
	.BYTE	135		; INI
	.BYTE	136		; INIR
	.BYTE	137		; LDD
	.BYTE	138		; LDDR
	.BYTE	139		; LDI
	.BYTE	140		; LDIR
	.BYTE	141		; NEG
	.BYTE	142		; OR
	.BYTE	145		; OTDR
	.BYTE	146		; OTIR
	.BYTE	147		; OUT
	.BYTE	150		; OUTD
	.BYTE	151		; OUTI
	.BYTE	152		; RES
	.BYTE	154		; RETI
	.BYTE	155		; RETN
	.BYTE	156		; RL
	.BYTE	158		; RLC
	.BYTE	160		; RLD
	.BYTE	161		; RR
	.BYTE	163		; RRC
	.BYTE	165		; RRD
	.BYTE	166		; RST
	.BYTE	167		; SBC
	.BYTE	174		; SET
	.BYTE	176		; SLA
	.BYTE	178		; SRA
	.BYTE	180		; SRL
	.BYTE	182		; SUB
	.BYTE	185		; XOR
	.BYTE	188		; .BYTE
	.BYTE	189		; DEFM
	.BYTE	190		; DEFW
	.BYTE	191		; DEFS
	.BYTE	192		; ENDIF
	.BYTE	193		; GLOBAL
	.BYTE	194		; IF
	.BYTE	195		; ORG
	.BYTE	196		; END
	.BYTE	198		; EJECT
	.BYTE	199		; TITLE
	.BYTE	200		; LIST
	.BYTE	201		; NLIST
	.BYTE	202		; NAMF
	.BYTE	203		; PSECT
	.BYTE	204		; MACR
	.BYTE	205		; ENDM
	.BYTE	206		; EQU
	.BYTE	207		; DEFL
	.BYTE	208		; END OF TABLE (REQUIRED)
;
OPTABL:	.BYTE	026H,0DDH,027H
	.BYTE	05BH,026H,09DH,01FH,01BH,021H,0FCH,026H,0FCH,016H,0BCH,01BH,0C7H,01CH,007H,03EH
	.BYTE	087H,011H,0EFH,011H,0F0H,041H,0FAH,012H,007H,012H,047H,011H,0C8H,011H,0C9H,036H
	.BYTE	08FH,036H,090H,036H,091H,036H,08AH,026H,09CH,02EH,08FH,02EH,090H,03EH,091H,02EH
	.BYTE	09CH,02EH,08AH,053H,0FAH,054H,03AH,044H,07AH,052H,0BAH,057H,03AH,014H,04AH,017H
	.BYTE	00AH,0BFH,09AH,0C6H,095H,0C6H,098H,0C6H,094H,0C6H,081H,04FH,09AH,036H,095H,036H
	.BYTE	098H,036H,094H,036H,081H,036H,097H,036H,093H,036H,096H,036H,092H,03FH,09DH,06FH
	.BYTE	09AH,06FH,0BCH,02FH,09DH,06FH,0BCH,01FH,08FH,01FH,090H,01FH,091H,01FH,08AH,01FH
	.BYTE	09CH,02FH,09DH,06FH,0BCH,01FH,08FH,01FH,090H,01FH,091H,01FH,08AH,01FH,09CH,01FH
	.BYTE	08FH,01FH,090H,01FH,091H,01FH,08DH,01FH,09CH,01FH,08FH,01FH,090H,01FH,091H,01FH
	.BYTE	08DH,01FH,09CH,04FH,09AH,036H,095H,036H,098H,036H,094H,036H,081H,036H,097H,036H
	.BYTE	093H,036H,096H,036H,092H,01FH,086H,01FH,0ABH,01FH,0ACH,01FH,0BEH,01FH,095H,01FH
	.BYTE	098H,01FH,094H,01FH,081H,01FH,097H,01FH,093H,01FH,096H,01FH,092H,047H,047H,036H
	.BYTE	087H,05FH,007H,013H,0D1H,014H,011H,014H,051H,012H,091H,047H,047H,036H,087H,05FH
	.BYTE	007H,013H,0D1H,014H,011H,014H,051H,012H,091H,013H,0DCH,014H,01CH,012H,09CH,012H
	.BYTE	0CBH,013H,00CH,03FH,09DH,06FH,09AH,06FH,0BCH,057H,05AH,04FH,01AH,01FH,0BEH,01FH
	.BYTE	0BEH,01FH,0BEH,01FH,0BEH,0BFH,09AH,014H,050H,013H,08DH,014H,06AH,017H,02AH,09FH
	.BYTE	09AH,03EH,087H,088H,05BH,018H,059H,01FH,0BEH,01FH,0BEH,01FH,0BEH,01FH,0BEH,01FH
	.BYTE	0BEH,01FH,0BEH,01FH,0BEH,01FH,0BEH,01FH,0BEH,03FH,09DH,06FH,09AH,06FH,0BCH,01FH
	.BYTE	0BEH,01FH,0BEH,061H,0FAH,071H,0E1H,076H,0E1H,01FH,0BEH,01FH,0BEH,057H,05AH,04FH
	.BYTE	01AH,01FH,0BEH,01FH,0BEH,04FH,09DH,03FH,0BCH,04FH,09DH,03FH,0BCH,01FH,0BEH,04FH
	.BYTE	09DH,03FH,0BCH,04FH,09DH,03FH,0BCH,01FH,0BEH,06FH,09AH,047H,047H,036H,087H,05FH
	.BYTE	007H,013H,0D1H,014H,011H,014H,051H,012H,091H,057H,05AH,04FH,01AH,04FH,09DH,03FH
	.BYTE	0BCH,04FH,09DH,03FH,0BCH,04FH,09DH,03FH,0BCH,03FH,09DH,06FH,09AH,06FH,0BCH,03FH
	.BYTE	09DH,06FH,09AH,06FH,0BCH,05FH,09AH,00FH,09AH,0AFH,09AH,00FH,09AH,00FH,0BEH,00FH
	.BYTE	09AH,00FH,09AH,00FH,09AH,00FH,0BEH,00FH,09AH,00FH,0BEH,007H,0DFH,00FH,09FH,00FH
	.BYTE	09FH,00FH,09AH,007H,0DFH,007H,0DFH,00FH,0BEH,00FH,09AH,00FH,09AH
;
; POINTS FROM OPTABL INDEX TO
; BYTONE, BYTWO, AND BYTFOR.
;
INSPTR:	.BYTE	13		; LD REGHL,REG
	.BYTE	13		; LD REG,REGHL
	.BYTE	63		; LD REGHL,EXP
	.BYTE	164		; LD REG,PIXIYP
	.BYTE	165		; LD PIXIYP,A
	.BYTE	165		; LD PIXIYP,REG
	.BYTE	176		; LD PIXIYP,EXP
	.BYTE	14		; LD A,PBCP
	.BYTE	15		; LD A,PDEP
	.BYTE	138		; LD A,PEXP
	.BYTE	16		; LD PBCP,A
	.BYTE	17		; LD PDEP,A
	.BYTE	139		; LD PEXP,A
	.BYTE	80		; LD A,I
	.BYTE	81		; LD A,R
	.BYTE	82		; LD I,A
	.BYTE	83		; LD R,A
	.BYTE	140		; LD BC,EXP
	.BYTE	141		; LD DE,EXP
	.BYTE	142		; LD HL,EXP
; 21
	.BYTE	143		; LD SP,EXP
	.BYTE	177		; LD IXIY,EXP
	.BYTE	178		; LD BC,PEXP
	.BYTE	179		; LD DE,PEXP
	.BYTE	144		; LD HL,PEXP
	.BYTE	180		; LD IXIY,PEXP
	.BYTE	181		; LD SP,PEXP
	.BYTE	182		; LD PEXP,BC
	.BYTE	183		; LD PEXP,DE
	.BYTE	145		; LD PEXP,HL
	.BYTE	185		; LD PEXP,SP
	.BYTE	184		; LD PEXP,IXIY
	.BYTE	18		; LD SP,HL
	.BYTE	84		; LD SP,IXIY
	.BYTE	64		; JR EXP,NULL
	.BYTE	65		; JR NZ,EXP
	.BYTE	66		; JR Z,EXP
	.BYTE	67		; JR NC,EXP
	.BYTE	68		; JR C,EXP
	.BYTE	146		; CALL EXP,NULL
; 41
	.BYTE	147		; CALL NZ,EXP
	.BYTE	148		; CALL Z,EXP
	.BYTE	149		; CALL NC,EXP
	.BYTE	150		; CALL C,EXP
	.BYTE	151		; CALL PO,EXP
	.BYTE	152		; CALL PE,EXP
	.BYTE	153		; CALL P,EXP
	.BYTE	154		; CALL M,EXP
	.BYTE	19		; CP REGHL
	.BYTE	69		; CP EXP
	.BYTE	166		; CP PIXIYP
	.BYTE	20		; INC REGHL
	.BYTE	167		; INC PIXIYP
	.BYTE	21		; INC BC
	.BYTE	22		; INC DE
	.BYTE	23		; INC HL
	.BYTE	24		; INC SP
	.BYTE	85		; INC IXIY
	.BYTE	25		; DEC REGHL
	.BYTE	168		; DEC PIXIYP
; 61
	.BYTE	26		; DEC BC
	.BYTE	27		; DEC DE
	.BYTE	28		; DEC HL
	.BYTE	29		; DEC SP
	.BYTE	86		; DEC IXIY
	.BYTE	30		; POP BC
	.BYTE	31		; POP DE
	.BYTE	32		; POP HL
	.BYTE	33		; POP AF
	.BYTE	87		; POP IXIY
	.BYTE	34		; PUSH BC
	.BYTE	35		; PUSH DE
	.BYTE	36		; PUSH HL
	.BYTE	37		; PUSH AF
	.BYTE	88		; PUSH IXIY
	.BYTE	155		; JP EXP
	.BYTE	156		; JP NZ,EXP
	.BYTE	157		; JP Z,EXP
	.BYTE	158		; JP NC,EXP
	.BYTE	159		; JP C,EXP
; 81
	.BYTE	160		; JP PO,EXP
	.BYTE	161		; JP PE,EXP
	.BYTE	162		; JP P,EXP
	.BYTE	163		; JP M,EXP
	.BYTE	38		; PHLP
	.BYTE	89		; JP PIXP
	.BYTE	89		; JP PIYP
	.BYTE	39		; RET
	.BYTE	40		; RET NZ
	.BYTE	41		; RET Z
	.BYTE	42		; RET NC
	.BYTE	43		; RET C
	.BYTE	44		; RET PO
	.BYTE	45		; RET PE
	.BYTE	46		; RET P
	.BYTE	47		; RET M
	.BYTE	48		; ADC A,REGHL
	.BYTE	70		; ADC A,EXP
	.BYTE	169		; ADC A,PIXIYP
	.BYTE	90		; ADC HL,BC
; 101
	.BYTE	91		; ADC HL,DE
	.BYTE	92		; ADC HL,HL
	.BYTE	93		; ADC HL,SP
	.BYTE	49		; ADD A,REGHL
	.BYTE	71		; ADD A,EXP
	.BYTE	170		; ADD A,PIXIYP
	.BYTE	50		; ADD HL,BC
	.BYTE	51		; ADD HL,DE
	.BYTE	52		; ADD HL,HL
	.BYTE	53		; ADD HL,SP
	.BYTE	94		; ADD IXIY,BC
	.BYTE	95		; ADD IXIY,DE
	.BYTE	96		; ADD IXIY,SP
	.BYTE	97		; ADD IX,IX
	.BYTE	97		; ADD IY,IY
	.BYTE	54		; AND REGHL
	.BYTE	72		; AND EXP
	.BYTE	171		; AND PIXIYP
	.BYTE	98		; BIT EXP,REGHL
	.BYTE	186		; BIT EXP,PIXIYP
; 121
	.BYTE	99		; CPD
	.BYTE	100		; CPDR
	.BYTE	101		; CPI
	.BYTE	102		; CPIR
	.BYTE	73		; DJNZ EXP
	.BYTE	55		; EX DE,HL
	.BYTE	56		; EX AF,AF'
	.BYTE	57		; EX PSPP,HL
	.BYTE	103		; EX PSPP,IXIY
	.BYTE	104		; IM EXP
	.BYTE	74		; IN A,PEXP
	.BYTE	105		; IN REG,PCP
	.BYTE	106		; IN F,PCP
	.BYTE	107		; IND
	.BYTE	108		; INDR
	.BYTE	109		; INI
	.BYTE	110		; INIR
	.BYTE	111		; LDD
	.BYTE	112		; LDDR
	.BYTE	 113		; LDI
; 141
	.BYTE	114		; LDIR
	.BYTE	115		; NEG
	.BYTE	58		; OR REGHL
	.BYTE	75		; OR EXP
	.BYTE	172		; OR PIXIYP
	.BYTE	116		; OTDR
	.BYTE	117		; OTIR
	.BYTE	76		; OUT PEXP,A
	.BYTE	118		; OUT PCP,A
	.BYTE	118		; OUT PCP,REG
	.BYTE	119		; OUTD
	.BYTE	120		; OUTI
	.BYTE	121		; RES EXP,REGHL
	.BYTE	187		; RES EXP,PIXIYP
	.BYTE	122		; RETI
	.BYTE	123		; RETN
	.BYTE	124		; RL REGHL
	.BYTE	188		; RL PIXIYP
	.BYTE	125		; RLC REGHL
	.BYTE	189		; RLC PIXIYP
; 161
	.BYTE	126		; RLD
	.BYTE	127		; RR REGHL
	.BYTE	190		; RR PIXIYP
	.BYTE	128		; RRC REGHL
	.BYTE	191		; RRC PIXIYP
	.BYTE	129		; RRD
	.BYTE	59		; RST EXP
	.BYTE	60		; SBC A,REGHL
	.BYTE	77		; SBC A,EXP
	.BYTE	173		; SBC A,PIXIYP
	.BYTE	130		; SBC HL,BC
	.BYTE	131		; SBC HL,DE
	.BYTE	132		; SBC HL,HL
	.BYTE	133		; SBC HL,SP
	.BYTE	134		; SET EXP,REGHL
	.BYTE	192		; SET EXP,PIXIYP
	.BYTE	135		; SLA REGHL
	.BYTE	193		; SLA PIXIYP
	.BYTE	136		; SRA REGHL
	.BYTE	194		; SRA PIXIYP
; 181
	.BYTE	137		; SRL REGHL
	.BYTE	195		; SRL PIXIYP
	.BYTE	61		; SUB REGHL
	.BYTE	78		; SUB EXP
	.BYTE	174		; SUB PIXIYP
	.BYTE	62		; XOR REGHL
	.BYTE	79		; XOR EXP
	.BYTE	175		; XOR PIXIYP
;
BYTONE:	.BYTE	3FH		; CCF
	.BYTE	2FH		; CPL
	.BYTE	27H		; DAA
	.BYTE	0F3H		; DI
	.BYTE	0FBH		; EI
	.BYTE	0D9H		; EXX
	.BYTE	076H		; HALT
	.BYTE	0		; NOP
	.BYTE	17H		; RLA
	.BYTE	07H		; RLCA
	.BYTE	1FH		; RRA
	.BYTE	0FH		; RRCA
	.BYTE	37H		; SCF
;
;BOUNDARY
;
; BYTONE FOR ONE BYTE OPCODES
;
	.BYTE	40H		; LD REGHL,REG AND LD REG,REGHL
	.BYTE	0AH		; LD A,PBCP
	.BYTE	1AH		; LD A,PDEP
	.BYTE	02H		; LD PBCP,A
	.BYTE	12H		; LD PDEP,A
	.BYTE	0F9H		; LD SP,HL
	.BYTE	0B8H		; CP REGHL
	.BYTE	4		; INC REGHL
	.BYTE	3		; INC BC
	.BYTE	13H		; INC DE
	.BYTE	23H		; INC HL
	.BYTE	33H		; INC SP
	.BYTE	5		; DEC REGHL
	.BYTE	0BH		; DEC BC
	.BYTE	1BH		; DEC DE
	.BYTE	2BH		; DEC HL
	.BYTE	3BH		; DEC SP
	.BYTE	0C1H		; POP BC
	.BYTE	0D1H		; POP DE
	.BYTE	0E1H		; POP HL
	.BYTE	0F1H		; POP AF
	.BYTE	0C5H		; PUSH BC
	.BYTE	0D5H		; PUSH DE
	.BYTE	0E5H		; PUSH HL
	.BYTE	0F5H		; PUSH AF
;
	.BYTE	0E9H		; JP PHLP
	.BYTE	0C9H		; RET
	.BYTE	0C0H		;
	.BYTE	0C8H		;
	.BYTE	0D0H		;
	.BYTE	0D8H		;
	.BYTE	0E0H		;
	.BYTE	0E8H		;
	.BYTE	0F0H		;
	.BYTE	0F8H		;
	.BYTE	88H		; ADC A,REGHL
	.BYTE	80H		; ADD A,REGHL
	.BYTE	9		; ADD HL,BC
	.BYTE	19H		; ADD HL,DE
	.BYTE	29H		; ADD HL,HL
	.BYTE	39H		; ADD HL,SP
	.BYTE	0A0H		; AND REGHL
	.BYTE	0EBH		; EX DE,HL
	.BYTE	08H		; EX AF,AF'
	.BYTE	0E3H		; EX PSPP,HL
	.BYTE	0B0H		; OR REGHL
	.BYTE	0C7H		; RST P
	.BYTE	98H		; SBC A,REGHL
	.BYTE	90H		; SUB REGHL
	.BYTE	0A8H		; XOR REGHL
;
; BYTONE FOR 2BYTE OPCODES WITH ONLY ONE BYTE
; DEFINED... THE SECOND BYTE IS NOT
; A SPECIAL OPCODE.
;
	.BYTE	06H		; LD REGHL,EXP
	.BYTE	18H		; JR EXP
	.BYTE	20H		;
	.BYTE	28H		;
	.BYTE	30H		;
	.BYTE	38H		;
	.BYTE	0FEH		; CP EXP
	.BYTE	0CEH		; ADC A,EXP
	.BYTE	0C6H		; ADD A,EXP
	.BYTE	0E6H		; AND EXP
	.BYTE	10H		; DJNZ EXP
	.BYTE	0DBH		; IN A,PEXP
	.BYTE	0F6H		; OR EXP
	.BYTE	0D3H		; OUT PEXP,A
	.BYTE	0DEH		; SBC A,EXP
	.BYTE	0D6H		; SUB EXP
	.BYTE	0EEH		; XOR EXP
;
; BOUNDARY
;
; TWO BYTE OPCODES WITH A SPECIAL CODE IN BYTE 2
;
	.BYTE	0EDH		; LD A,I
	.BYTE	0EDH		; LD A,R
	.BYTE	0EDH		; LD I,A
	.BYTE	0EDH		; LD R,A
	.BYTE	0DDH		; LD SP,IXIY
	.BYTE	0DDH		; INC IXIY
	.BYTE	0DDH		; DEC IXIY
	.BYTE	0DDH		; POP IXIY
	.BYTE	0DDH		; PUSH IXIY
	.BYTE	0DDH		; JP PIXIYP
	.BYTE	0EDH		; ADC HL,BC
	.BYTE	0EDH		; ADC HL,DE
	.BYTE	0EDH		; ADC HL,HL
	.BYTE	0EDH		; ADC HL,SP
	.BYTE	0DDH		; ADD IXIY,BC
	.BYTE	0DDH		; ADD IXIY,DE
	.BYTE	0DDH		; ADD IXIY,SP
	.BYTE	0DDH		; ADD IX,IX
	.BYTE	0CBH		; BIT EXP,REGHL
	.BYTE	0EDH		; CPD
	.BYTE	0EDH		; CPDR
	.BYTE	0EDH		; CPI
	.BYTE	0EDH		; CPIR
	.BYTE	0DDH		; EX PSPP,IXIY
	.BYTE	0EDH		; IM EXP
	.BYTE	0EDH		; IN REG,PCP
	.BYTE	0EDH		; IN F,PCP
	.BYTE	0EDH		; IND
	.BYTE	0EDH		; INDR
	.BYTE	0EDH		; INI
	.BYTE	0EDH		; INIR
	.BYTE	0EDH		; LDD
	.BYTE	0EDH		; LDDR
;
	.BYTE	0EDH		; LDI
	.BYTE	0EDH		; LDIR
	.BYTE	0EDH		; NEG
	.BYTE	0EDH		; OTDR
	.BYTE	0EDH		; OTIR
	.BYTE	0EDH		; OUT PCP,REG
	.BYTE	0EDH		; OUTD
	.BYTE	0EDH		; OUTI
	.BYTE	0CBH		; RES EXP,REGHL
	.BYTE	0EDH		; RETI
	.BYTE	0EDH		; RETN
	.BYTE	0CBH		; RL REGHL
	.BYTE	0CBH		; RLC REGHL
	.BYTE	0EDH		; RLD
	.BYTE	0CBH		; RR REGHL
	.BYTE	0CBH		; RRC REGHL
	.BYTE	0EDH		; RRD
	.BYTE	0EDH		; SBC HL,BC
	.BYTE	0EDH		; SBC HL,DE
	.BYTE	0EDH		; SBC HL,HL
	.BYTE	0EDH		; SBC HL,SP
	.BYTE	0CBH		; SET EXP,REGHL
	.BYTE	0CBH		; SLA REGHL
	.BYTE	0CBH		; SRA REGHL
	.BYTE	0CBH		; SRL REGHL
;
;BOUNDARY
;
; BYTONE FOR 1ST BYTE OF 3 BYTE OPCODES
; WITH NO SPECIAL CODE IN BYTE 2
;
	.BYTE	3AH		; LD A,PEXP
	.BYTE	32H		; LD PEXP,A
	.BYTE	1		; LD BC,EXP
	.BYTE	11H		; LD DE,EXP
	.BYTE	21H		; LD HL,EXP
	.BYTE	31H		; LD SP,EXP
	.BYTE	2AH		; LD HL,PEXP
	.BYTE	22H		; LD PEXP,HL
	.BYTE	0CDH		; CALL EXP
	.BYTE	0C4H		;
	.BYTE	0CCH		;
	.BYTE	0D4H		;
	.BYTE	0DCH		;
	.BYTE	0E4H		;
	.BYTE	0ECH		;
	.BYTE	0F4H		;
	.BYTE	0FCH		;
	.BYTE	0C3H		; JP EXP
	.BYTE	0C2H		;
	.BYTE	0CAH		;
	.BYTE	0D2H		;
	.BYTE	0DAH		;
	.BYTE	0E2H		;
	.BYTE	0EAH		;
	.BYTE	0F2H		;
	.BYTE	0FAH		;
;
; BYTONE OF THREE BYTE OPCODES WITH SPECIAL
; CODE IN BYTE 2
;
	.BYTE	0DDH		; LD REG,PIXIYP
	.BYTE	0DDH		; LD PIXIYP,REG
	.BYTE	0DDH		; CP PIXIYP
	.BYTE	0DDH		; INC PIXIYP
	.BYTE	0DDH		; DEC PIXIYP
	.BYTE	0DDH		; ADC A,PIXIYP
	.BYTE	0DDH		; ADD A,PIXIYP
	.BYTE	0DDH		; AND PIXIYP
	.BYTE	0DDH		; OR PIXIYP
	.BYTE	0DDH		; SBC A,PIXIYP
	.BYTE	0DDH		; SUB A,PIXIYP
	.BYTE	0DDH		; XOR PIXIYP
;
; BOUNDARY
; BYTONE FOR FOUR BYTE OPCODES WITH NO SPECIAL CODE IN
; BYTE 4
;
	.BYTE	0DDH		; LD PIXIYP,EXP
	.BYTE	0DDH		; LD IXIY,EXP
	.BYTE	0EDH		; LD BC,PEXP
	.BYTE	0EDH		; LD DE,PEXP
	.BYTE	0DDH		; LD IXIY,PEXP
	.BYTE	0EDH		; LD SP,PEXP
	.BYTE	0EDH		; LD PEXP,BC
	.BYTE	0EDH		; LD PEXP,DE
	.BYTE	0DDH		; LD PEXP,IXIY
	.BYTE	0EDH		; LD PEXP,SP
;
; FOUR BYTE OPCODES WITH SPECIAL CODE IN BYTE 4
;
	.BYTE	0DDH		; BIT EXP,PIXIYP
	.BYTE	0DDH		; RES
	.BYTE	0DDH		; RL PIXIYP
	.BYTE	0DDH		; RLC
	.BYTE	0DDH		; RR
	.BYTE	0DDH		; RRC
	.BYTE	0DDH		; SET
	.BYTE	0DDH		; SLA
	.BYTE	0DDH		; SRA
	.BYTE	0DDH		; SRL
;
; BYTWO FOR 2 BYTE OPCODES
;
BYTWO	.BYTE	57H		; LD A,I
	.BYTE	5FH		; LD A,R
	.BYTE	47H		; LD I,A
	.BYTE	4FH		; LD R,A
	.BYTE	0F9H		; LD SP,IXIY
	.BYTE	23H		; INC IXIY
	.BYTE	2BH		; DEC IXIY
	.BYTE	0E1H		; POP IXIY
	.BYTE	0E5H		; PUSH IXIY
	.BYTE	0E9H		; JP PIXIYP
	.BYTE	4AH		; ADC HL,BC
	.BYTE	5AH		; ADCHL,DE
	.BYTE	6AH		; ADC HL,HL
	.BYTE	7AH		; ADC HL,SP
	.BYTE	09H		; ADC IXIY,BC
	.BYTE	19H		; ADC IXIY,DE
	.BYTE	39H		; ADD IXIY,SP
	.BYTE	29H		; ADD IX,IX
	.BYTE	040H		; BIT EXP,REGHL
	.BYTE	0A9H		; CPD
	.BYTE	0B9H		; CPDR
	.BYTE	0A1H		; CPI
	.BYTE	0B1H		; CPIR
	.BYTE	0E3H		; EX PSPP,IXIY
;
	.BYTE	46H		; IM EXP
	.BYTE	40H		; IN REG,PCP
	.BYTE	70H		; IN F,PCP
	.BYTE	0AAH		; IND
	.BYTE	0BAH		; INDR
	.BYTE	0A2H		; INI
	.BYTE	0B2H		; INIR
	.BYTE	0A8H		; LDD
	.BYTE	0B8H		; LDDR
	.BYTE	0A0H		; LDI
	.BYTE	0B0H		; LDIR
	.BYTE	44H		; NEG
	.BYTE	0BBH		; OTDR
	.BYTE	0B3H		; OTIR
	.BYTE	41H		; OUT PCP,REG
	.BYTE	0ABH		; OUTD
	.BYTE	0A3H		; OUTI
	.BYTE	80H		; RES EXP,REGHL
	.BYTE	4DH		; RETI
	.BYTE	045H		; RETN
	.BYTE	10H		; RL REGHL
	.BYTE	0		; RLC REGHL
	.BYTE	6FH		; RLD
	.BYTE	18H		; RR REGHL
	.BYTE	08H		; RRC REGHL
	.BYTE	67H		; RRD
;
	.BYTE	42H		; SBC HL,BC
	.BYTE	52H		; SBC HL,DE
	.BYTE	62H		; SBC HL,HL
	.BYTE	72H		; SBC HL,SP
	.BYTE	0C0H		; SET EXP,REGHL
	.BYTE	20H		; SLA REGHL
	.BYTE	28H		; SRA REGHL
	.BYTE	38H		; SRL REGHL
;
CHKOPR:	PUSH	HL		; CHECK FOR OPERATOR
	PUSH	BC		;
	LD	HL,OPRTAB	; HL -> TABLE OF OPERATORS
	LD	BC,OPRLNG	; BC = LENGTH OF TABLE
	CPIR			;
	POP	BC		; RESTORE REGS
	POP	HL		;
	RET			;
;
OPRTAB:	.BYTE	27H		;
	.BYTE	'('		;
	.BYTE	')'		;
	.BYTE	'*'		;
	.BYTE	'+'		;
	.BYTE	'-'		;
	.BYTE	'.'		;
	.BYTE	'/'		;
	.BYTE	'<'		;
	.BYTE	'='		;
	.BYTE	'>'		;
OPRLNG	.EQU	$-OPRTAB
;
	.BYTE	0FFH		;
;
; BYTWO FOR THREE BYTE OPCODES WITH
; NO CODE IN BYTE 2
;
	.BYTE	000H,046H,070H,0BEH,034H,035H,08EH,086H,0A6H,0B6H,09EH,096H,0AEH,036H,021H,04BH
	.BYTE	05BH,02AH,07BH,043H,053H,022H,073H,0CBH,0CBH,0CBH,0CBH,0CBH,0CBH,0CBH,0CBH,0CBH
	.BYTE	0CBH
;
BYTFOR:	.BYTE	046H,086H,016H,006H,01EH,00EH,0C6H,026H,02EH,03EH
;
; END OF TABLE
;
	.END

